
#LOCAL_PATH这个变量用于给出当前文件的路径。你必须在Android.mk的开头定义
LOCAL_PATH := $(call my-dir)

include $(CLEAR_VARS)
LOCAL_MODULE            := hpr
LOCAL_SRC_FILES         := libs/libhpr.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE            := ecs
LOCAL_SRC_FILES         := libs/libecs.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE            := g711
LOCAL_SRC_FILES         := libs/libg711.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE            := g722
LOCAL_SRC_FILES         := libs/libg722.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE            := g726
LOCAL_SRC_FILES         := libs/libg726.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE            := AEC_android
LOCAL_SRC_FILES         := libs/libAEC_android.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE            := ANR_android
LOCAL_SRC_FILES         := libs/libANR_android.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)

#LOCAL_ARM_MODE默认情况下，arm目标二进制会以thumb的形式生成（16位），你可以通过设置这个变量为arm如果你希望你的module是以32位指令的形式。
#Thumb指令集不是完整的指令集，它是ARM指令集的子集
#Thumb指令与ARM指令的时间效率和空间效率关系为:
#*存储空间约为ARM代码的60％～70％
#*指令数比ARM代码多约30％～40％
#*存储器为32位时ARM代码比Thumb代码快约40％
#*存储器为16位时Thumb比ARM代码快约40～50％
#*使用Thumb代码，存储器的功耗会降低约30％
LOCAL_ARM_MODE := arm

#LOCAL_MODULE这是你模块的名字，它必须是唯一的，而且不能包含空格
LOCAL_MODULE := MCRSDK

#LOCAL_MULTILIB配置编译
#"both": build both 32-bit and 64-bit.
#"32": build only 32-bit.
#"64": build only 64-bit.
#LOCAL_MULTILIB := both

#LOCAL_MODULE_TAGS ：=user eng tests optional 
#user: 指该模块只在user版本下才编译 
#eng: 指该模块只在eng版本下才编译 
#tests: 指该模块只在tests版本下才编译
#optional:指该模块在所有版本下都编译 
LOCAL_MODULE_TAGS:= optional

#include header

#公共类源文件
PUBLIC_SRC := MCRSDK/public/src/MCRPrint.cpp \
			  MCRSDK/public/src/hik_malloc.cpp
   
#rtspclientsdk的源文件
RTSPCLIENT_SRC := MCRSDK/RtspClientSDK/src/base64.cpp \
			      MCRSDK/RtspClientSDK/src/CString.cpp \
			      MCRSDK/RtspClientSDK/src/EventWrapperEx.cpp \
			      MCRSDK/RtspClientSDK/src/MsgManage.cpp \
			      MCRSDK/RtspClientSDK/src/RtcpPacket.cpp \
			      MCRSDK/RtspClientSDK/src/RtcpTcpTransEngine.cpp \
			      MCRSDK/RtspClientSDK/src/RtcpUdpTransEngine.cpp \
			      MCRSDK/RtspClientSDK/src/RtpPacket.cpp \
			      MCRSDK/RtspClientSDK/src/RtpRtcpTransEngine.cpp \
			      MCRSDK/RtspClientSDK/src/RtpTcpTransEngine.cpp \
			      MCRSDK/RtspClientSDK/src/RtpUdpTransEngine.cpp \
			      MCRSDK/RtspClientSDK/src/RtpUtil.cpp \
			      MCRSDK/RtspClientSDK/src/RtspClientEngine.cpp \
			      MCRSDK/RtspClientSDK/src/RtspClientSDK.cpp \
			      MCRSDK/RtspClientSDK/src/RtspCommon.cpp \
			      MCRSDK/RtspClientSDK/src/RtspParser.cpp \
			      MCRSDK/RtspClientSDK/src/TcpInterleavedPairs.cpp \
			      MCRSDK/RtspClientSDK/src/UdpTcpPortPairs.cpp
			     
#消息长连接的的源文件			     
PUSHCLIENT_SRC := MCRSDK/PushClientSDK/src/PushManager.cpp \
			      MCRSDK/PushClientSDK/src/PushClientSDK.cpp	
        
#自定义的跨平台类源文件
HPR_SRC := MCRSDK/hpr2/src/hpr2_mutex.cpp \
           MCRSDK/hpr2/src/hpr2_rmm.cpp \
           MCRSDK/hpr2/src/hpr2_sleep.cpp \
           MCRSDK/hpr2/src/hpr2_thread.cpp \
           MCRSDK/hpr2/src/hpr2_byte_order.cpp
           		
#音频数据编解码码和缓冲类源文件           
AUDIO_CODEC_SRC := 	MCRSDK/AudioCodec/src/AudioCodec.cpp \
					MCRSDK/AudioCodec/src/AudioBuffer.cpp \
					MCRSDK/AudioCodec/src/AudioCodecInferface.cpp \
					MCRSDK/aec/src/AECSpeaker.cpp \
					MCRSDK/anr/src/ByteBuffer.cpp \
					MCRSDK/anr/src/Denoise.cpp
					
#android jni类源文件           
TALK_CLIENT_SRC := 	MCRSDK/TalkClientSDK/src/TalkEngine.cpp \
					MCRSDK/TalkClientSDK/src/TalkNetSDK.cpp \
					MCRSDK/TalkClientSDK/src/TalkPacket.cpp \
					MCRSDK/TalkClientSDK/src/UDPSer.cpp \
					MCRSDK/TalkClientSDK/src/TalkClientSDK.cpp
	
#android jni类源文件           
JNI_SRC := 	JniInterface/src/com_hik_mcrsdk_MCRSDK.cpp \
			JniInterface/src/com_hik_mcrsdk_push_PushClient.cpp \
			JniInterface/src/com_hik_mcrsdk_rtsp_RtspClient.cpp	\
			JniInterface/src/com_hik_mcrsdk_talk_TalkClientSDK.cpp
	     

#LOCAL_SRC_FILES这是要编译的源代码文件列表
LOCAL_C_INCLUDES := ${LOCAL_PATH}/MCRSDK \
					${LOCAL_PATH}/MCRSDK/hpr \
					${LOCAL_PATH}/MCRSDK/hpr2/include \
					${LOCAL_PATH}/MCRSDK/public/include \
					${LOCAL_PATH}/MCRSDK/RtspClientSDK/include \
					${LOCAL_PATH}/MCRSDK/PushClientSDK/include \
					${LOCAL_PATH}/MCRSDK/AudioCodec/include	\
					${LOCAL_PATH}/MCRSDK/TalkClientSDK/include \
					${LOCAL_PATH}/MCRSDK/aec/include \
					${LOCAL_PATH}/MCRSDK/anr/include \
					${LOCAL_PATH}/JniInterface/include \
					${LOCAL_PATH}/ecs/include
					
LOCAL_SRC_FILES := MCRSDK/MCRSDK.cpp \
				   $(PUBLIC_SRC) \
				   $(HPR_SRC) \
				   $(PUSHCLIENT_SRC) \
				   $(RTSPCLIENT_SRC) \
				   $(AUDIO_CODEC_SRC) \
			       $(TALK_CLIENT_SRC) \
			       $(JNI_SRC)
			       
			       
#$(LIBEVENT_SRC) \
#$(HTTP_SRC) \			       
				   
#LOCAL_STATIC_LIBRARIES应该链接到这个模块的静态库列表（使用BUILD_STATIC_LIBRARY生成），这仅仅对共享库模块才有意义。
#LOCAL_SHARED_LIBRARIES这个模块在运行时要依赖的共享库模块列表，在链接时需要，在生成文件时嵌入的相应的信息

#LOCAL_CFLAGS可选的编译器选项，在编译C代码文件的时候使用
#LOCAL_CFLAGS-D，增加全局宏定义。
#LOCAL_CFLAGS := -DUSE_JSC相当于在所有源文件中增加一个#define USE_JSC
#LOCAL_CFLAGS := -DUSE_COPY_BIT=1相当于在所有源文件中增加一个#define USE_COPY_BIT 1	
LOCAL_CFLAGS := -DHAVE_CONFIG_H -DANDROID -fvisibility=hidden -DTIXML_USE_STL -fexceptions

#LOCAL_CPPFLAGS与LOCAL_CFLAGS相同，但是对C 和　C++ source files都适用

#add libs
#LOCAL_LDLIBS编译你的模块要使用的附加的链接器选项。这对于使用”-l”前缀传递指定库的名字是有用的
#LOCAL_LDLIBS += -llog -L$(LOCAL_PATH)/libs -lhpr -lg711 -lg722 -lg726 -lecs -lAEC_android -lANR_android

LOCAL_STATIC_LIBRARIES := cpufeatures hpr ecs g711 g722 g726 AEC_android ANR_android
LOCAL_LDLIBS += -llog
TARGET_PLATFORM := android-17

TARGET_ARCH_ABI :=armeabi armeabi-v7a
ifeq ($(TARGET_ARCH_ABI), armeabi-v7a)
#采用NEON优化技术    
LOCAL_ARM_NEON := true    
endif

#LOCAL_MODULE_PATH和LOCAL_UNSTRIPPED_PATH来指定最后的目标安装路径
#不同的文件系统路径用以下的宏进行选择：
#TARGET_ROOT_OUT：表示根文件系统。
#TARGET_OUT：表示system文件系统。
#TARGET_OUT_DATA：表示data文件系统。
#用法如：LOCAL_MODULE_PATH:=$(TARGET_ROOT_OUT)

						
include $(BUILD_SHARED_LIBRARY)