/*
 * com_hik_mcrsdk_MCRSDK.cpp
 *
 *  Created on: 2014-3-20
 *      Author: weilinfeng
 */

#include "com_hik_mcrsdk_MCRSDK.h"
#include "KLog.h"
#include "MCRSDK.h"
#include "Define.h"
#include <string>
JavaVM* gJavaVM;

jint JNI_OnLoad(JavaVM* vm, void* reserved)
{
	JNIEnv *jEnv;
	gJavaVM = vm;
	int result;

	if(vm->GetEnv((void**)&jEnv, JNI_VERSION_1_4) == JNI_OK)
	{
		LOGD("JNI_OnLoad->JNI Version:1.4");
		result =  JNI_VERSION_1_4;
	}
	else
	{
		LOGD("JNI_OnLoad->JNI Version:1.4 Error");
		result = -1;
	}
	LOGD("JNI_OnLoad success");
	return result;
}

/*
 * Class:     com_hik_mcrsdk_MCRSDK
 * Method:    init
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_com_hik_mcrsdk_MCRSDK_init
  (JNIEnv *, jclass)
{
	bool bRet = InitLib();
	if(!bRet) {
		LOGD("jni MCRSDK init lib fail");
		return false;
	}

	LOGD("jni MCRSDK init lib success");
	return true;
}

/*
 * Class:     com_hik_mcrsdk_MCRSDK
 * Method:    fini
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_com_hik_mcrsdk_MCRSDK_fini
  (JNIEnv *, jclass)
{

	bool bRet = FiniLib();
	if(!bRet) {
		LOGD("jni MCRSDK fini lib fail");
		return false;
	}

	LOGD("jni MCRSDK fini lib success");
	return true;
}

/*
 * Class:     com_hik_mcrsdk_MCRSDK
 * Method:    setPrint
 * Signature: (ILjava/lang/String;)Z
 */
JNIEXPORT jboolean JNICALL Java_com_hik_mcrsdk_MCRSDK_setPrint
  (JNIEnv *env, jclass , jint iflag, jstring jlogpath)
{
	const char* logpath = NULL;
	if(jlogpath != NULL) {
		logpath = env->GetStringUTFChars(jlogpath, NULL);
		std::string strPath;
		strPath.append(logpath);
		if ((strPath.find_last_of('/') + 1) == strPath.size())
		{
			strPath.append("MCRSDK.txt");
		}
		else
		{
			strPath.append("/MCRSDK.txt");
		}
		start_log((int)iflag, (char*)strPath.c_str());

		env->ReleaseStringUTFChars(jlogpath, logpath);
	}
	else
	{
		start_log((int)iflag, NULL);
	}
//	bool bRet = SetPrint((int)iflag, logpath);
//	if(!bRet) {
//		LOGD("jni MCRSDK setprint fail");
//		return false;
//	}
	LOGD("jni MCRSDK setprint success");
	return true;
}

