/*
 * com_hik_mcrsdk_push_PushClient.cpp
 *
 *  Created on: 2014-3-20
 *      Author: weilinfeng
 */
#include "com_hik_mcrsdk_push_PushClient.h"
#include "PushClientSDK.h"
#include "MCRPrint.h"
#include "Define.h"
#include <stdlib.h>

extern JavaVM* gJavaVM;

jobject oNotifyPacketListener = NULL;
jobject oConnectListener = NULL;
//add by chifengliang
/** 检查传入的字符是否是utf-8格式*/
void correctUtfBytes(char* bytes);
//end add by chifengliang

void NoticeCallback(JNIEnv *env, jobject notifyPacketListener, int type, char* buffer, int buflen, void* pUser)
{
	LOGD("NoticeCallback\n");

	if(buffer == NULL) {
		LOGD("NoticeCallback-> buffer == NULL\n");
		return;
	}

	if(buflen == 0) {
		LOGD("NoticeCallback-> buflen == 0\n");
		return;
	}

	if(PUSH_PACKET_TYPE != type) {
		LOGD("NoticeCallback-> PUSH_PACKET_TYPE != type \n");
		return;
	}

	PREVERSE_NOTIC_REQ_INFO pnotice = reinterpret_cast<PREVERSE_NOTIC_REQ_INFO>(buffer);
	if(pnotice == NULL)
	{
		LOGD("NoticeCallback-> pnotice == NULL\n");
		return;
	}

	LOGD("sessionId=%s", pnotice->mcuSessionId);
	LOGD("messageId=%s", pnotice->messageId);
	LOGD("messageType=%s", pnotice->messageType);
	LOGD("messageDescribe=%s", pnotice->messageTypeDescribe);
	LOGD("messageTitle=%s", pnotice->messageTitle);
	LOGD("ret=%s", pnotice->iRet);
	LOGD("NoticeCallback-> messageCreateTime:%d\n", pnotice->messageCreateTime);

	correctUtfBytes(pnotice->mcuSessionId);
	correctUtfBytes(pnotice->messageId);
	correctUtfBytes(pnotice->messageType);
	correctUtfBytes(pnotice->messageTypeDescribe);
	correctUtfBytes(pnotice->messageTitle);
	correctUtfBytes(pnotice->iRet);

	LOGD("correct sessionId=%s", pnotice->mcuSessionId);
	LOGD("correct messageId=%s", pnotice->messageId);
	LOGD("correct messageType=%s", pnotice->messageType);
	LOGD("correct messageDescribe=%s", pnotice->messageTypeDescribe);
	LOGD("correct messageTitle=%s", pnotice->messageTitle);
	LOGD("correct ret=%s", pnotice->iRet);

	jstring jmcuSessionId = env->NewStringUTF(pnotice->mcuSessionId);
	jstring jmsgId = env->NewStringUTF(pnotice->messageId);
	jstring jtype = env->NewStringUTF(pnotice->messageType);
	jstring jtypeDescribe = env->NewStringUTF(pnotice->messageTypeDescribe);
	jstring jtitle = env->NewStringUTF(pnotice->messageTitle);
	jlong jcreatetime = (jlong)pnotice->messageCreateTime;
	jstring jextendsStr = env->NewStringUTF(pnotice->iRet);

	jclass jnotifyClass = env->GetObjectClass(notifyPacketListener);
	jmethodID methodID = env->GetMethodID(jnotifyClass, "onPacket", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;JLjava/lang/String;)V");
	if (NULL != methodID)
	{
		env->CallVoidMethod(notifyPacketListener, methodID, jmcuSessionId, jmsgId, jtype, jtypeDescribe, jtitle, jcreatetime,jextendsStr);
	}
	else
	{
		LOGD("no such method named onPacket");
	}

	env-> DeleteLocalRef(jmcuSessionId);
	env-> DeleteLocalRef(jtype);
	env-> DeleteLocalRef(jtypeDescribe);
	env-> DeleteLocalRef(jtitle);
	env-> DeleteLocalRef(jmsgId);
	env->DeleteLocalRef(jnotifyClass);
	env->DeleteLocalRef(jextendsStr);
	jnotifyClass = NULL;

	LOGD("NoticeCallback Complete \n");
}

void correctUtfBytes(char* bytes)
{
	char three = 0;
	while (*bytes != '\0')
	{
		unsigned char utf8 = *(bytes++);
		three = 0;
		switch(utf8 >> 4)
		{
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
			break;
		case 0x08:
		case 0x09:
		case 0x0a:
		case 0x0b:
		case 0x0f:
			*(bytes-1) = '?';
			break;
		case 0x0e:
			utf8 = *(bytes++);
			if ((utf8&0xc0) != 0x80)
			{
				--bytes;
				*(bytes-1) = '?';
				break;
			}
			three = 1;
		case 0x0c:
		case 0x0d:
			utf8 = *(bytes++);
			if ((utf8 & 0xc0) != 0x80)
			{
				--bytes;
				if(three) --bytes;
				*(bytes-1) = '?';
			}
			break;
		}
	}
}

int PacketLister(int type, char* buffer, int buflen, void* pUser)
{
	LOGD("PacketLister \n");

	if(buffer == NULL) {
		return 0;
	}

	bool attach = false;
	JNIEnv* env = NULL;
	// add by chifengliang 在接收AM消息的时候出现崩溃
	jint ret = gJavaVM->GetEnv((void**)&env, JNI_VERSION_1_4);
	if (ret < 0)
	{
		LOGD("get jni JNIEnv error in version 1.4");
		ret = gJavaVM->AttachCurrentThread(&env, NULL);
		attach = true;
	}
	// end add by chifengliang
	if (ret < 0 || env == NULL)
	{
		LOGD("PacketLister->g_JavaVM AttachCurrentThread fail\n");
		return 0;
	}

	if (PUSH_PACKET_TYPE == type)
	{
		NoticeCallback(env, oNotifyPacketListener, type, buffer, buflen, pUser);
	}
	else
	{
		LOGD("PacketLister->not push packet\n");
	}

	if (attach)
	{
		gJavaVM->DetachCurrentThread();
	}
	LOGD("PacketLister Complete\n");
	return 0;
}

int ConnectionLister(int ErrorCode, void* pUser)
{
	LOGD("ConnectionLister->ConnectionLister\n");
	JNIEnv* env = NULL;
	// 获取虚拟机资源
	jint ret = gJavaVM->AttachCurrentThread(&env, NULL);
	if (ret < 0 || env == NULL)
	{
		LOGD("ConnectionLister->gJavaVM AttachCurrentThread fail\n");
		return 0;
	}

	jclass jconnectClass = env->GetObjectClass(oConnectListener);
	jmethodID methodID = env->GetMethodID(jconnectClass, "connectionClosedOnError", "(I)V");
	env->CallVoidMethod(oConnectListener, methodID, (jint)ErrorCode);
	// 释放局部引用
	env->DeleteLocalRef(jconnectClass);
	jconnectClass = NULL;

	// 释放虚拟机资源
	gJavaVM->DetachCurrentThread();
	LOGD("ConnectionLister->ConnectionLister Complete\n");
	return 0;
}

/*
 * Class:     com_hik_mcrsdk_push_PushClient
 * Method:    initLib
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_com_hik_mcrsdk_push_PushClient_initLib
  (JNIEnv *env, jclass jobj)
{
	LOGD("Java_com_hik_mcrsdk_push_PushClient_initLib");
	bool bRet = PushClientInit();
	if(!bRet) {
		LOGD("Java_com_hik_mcrsdk_push_PushClient_initLib MCRSDK push client init lib fail");
		return false;
	}

	LOGD("Java_com_hik_mcrsdk_push_PushClient_initLib MCRSDK push client init lib success");
	return true;
}

/*
 * Class:     com_hik_mcrsdk_push_PushClient
 * Method:    finiLib
 * Signature: ()Z
 */
JNIEXPORT void JNICALL Java_com_hik_mcrsdk_push_PushClient_finiLib
  (JNIEnv * env, jclass jobj)
{
	PushClientFini();
	LOGD("Java_com_hik_mcrsdk_push_PushClient_finiLib");
}

/*
 * Class:     com_hik_mcrsdk_push_PushClient
 * Method:    connect
 * Signature: (Ljava/lang/String;ILjava/lang/String;)I
 */
JNIEXPORT jint JNICALL Java_com_hik_mcrsdk_push_PushClient_connect
  (JNIEnv *env, jobject jobj, jstring jip, jint jport, jstring jsession)
{
	LOGD("Java_com_hik_mcrsdk_push_PushClient_connect");
	const char* ip = env->GetStringUTFChars(jip, NULL);
	const char* session = env->GetStringUTFChars(jsession, NULL);

	int iRet = PushClientConnect(ip, (int)jport, session, NULL);
	if(iRet == -1) {
		LOGD("Java_com_hik_mcrsdk_push_PushClient_connect MCRSDK Push Client Connect fail");
		return -1;
	}

	env->ReleaseStringUTFChars(jip, ip);
	env->ReleaseStringUTFChars(jsession, session);
	LOGD("Java_com_hik_mcrsdk_push_PushClient_connect MCRSDK Push Client Connect success");
	return iRet;
}

/*
 * Class:     com_hik_mcrsdk_push_PushClient
 * Method:    disConnect
 * Signature: ()Z
 */
JNIEXPORT void JNICALL Java_com_hik_mcrsdk_push_PushClient_disConnect
  (JNIEnv *env, jobject jobj)
{
	PushClientDisConnect();
	LOGD("Java_com_hik_mcrsdk_push_PushClient_disConnect");
}

/*
 * Class:     com_hik_mcrsdk_push_PushClient
 * Method:    addPacketListener
 * Signature: (Lcom/hik/mcrsdk/push/NotifyPacketLister;)V
 */
JNIEXPORT jboolean JNICALL Java_com_hik_mcrsdk_push_PushClient_addNotifyPacketLister
  (JNIEnv * env, jobject jobj, jobject jpacketobj)
{
	LOGD("Java_com_hik_mcrsdk_push_PushClient_addNotifyPacketLister");
	if(jpacketobj == NULL) {
		LOGD("Java_com_hik_mcrsdk_push_PushClient_addNotifyPacketLister jpacketobj == NULL");
		return false;
	}

	bool bRet = PushClientSetPacketLister(&PacketLister);
	if(!bRet){
		LOGD("Java_com_hik_mcrsdk_push_PushClient_addNotifyPacketLister PushClientSetPacketLister fail");
		return false;
	}

	oNotifyPacketListener = env->NewGlobalRef(jpacketobj);

	LOGD("Java_com_hik_mcrsdk_push_PushClient_addNotifyPacketLister MCRSDK Push Client Set Packet Lister success");
	return true;
}

/*
 * Class:     com_hik_mcrsdk_push_PushClient
 * Method:    addConnectionListener
 * Signature: (Lcom/hik/mcrsdk/push/ConnectionListener;)V
 */
JNIEXPORT jboolean JNICALL Java_com_hik_mcrsdk_push_PushClient_addConnectionListener
  (JNIEnv * env, jobject jobj, jobject jconnectobj)
{
	LOGD("Java_com_hik_mcrsdk_push_PushClient_addConnectionListener");
	if(jconnectobj == NULL) {
		LOGD("Java_com_hik_mcrsdk_push_PushClient_addConnectionListener jconnectobj == NULL");
		return false;
	}

	bool bRet = PushClientSetConnectionLister(ConnectionLister);
	if(!bRet){
		LOGD("Java_com_hik_mcrsdk_push_PushClient_addConnectionListener PushClientSetConnectionLister fail");
		return false;
	}

	oConnectListener = env->NewGlobalRef(jconnectobj);

	LOGD("Java_com_hik_mcrsdk_push_PushClient_addConnectionListener MCRSDK Push Client Set Connection Lister success");
	return true;
}
