/*
 * com_hik_mcrsdk_talk_TalkClientSDK.cpp
 *
 *  Created on: 2014-6-12
 *      Author: weilinfeng
 */
#include "com_hik_mcrsdk_talk_TalkClientSDK.h"
#include "TalkClientSDK.h"
#include "MCRPrint.h"
#include <string>

extern JavaVM* gJavaVM;

//typedef void (*pAudioInterfacePCMDataListener)(int type, char* buffer, unsigned int buflen, void* pUser);
//typedef void (*pMessageListener)(unsigned short vChannel, char* content, unsigned int contentlen, char* fromUserID, unsigned int userIDLen, void* pUser);
//typedef void (*pErrorListener)(int ErrorCode, char* pDescribe, unsigned int desLen, void* pUser);


jobject objPCMDataListenerr = NULL;
jobject objMessageListener = NULL;
jobject objErrorListener = NULL;

// 对讲PCM数据回调
void JNI_PCMDataListener(char* pData, unsigned int datalen, void* pUser) {
	//LOGD("JNI_PCMDataListener-> data len:%d", datalen);
	if(datalen <= 0 || pData == NULL) {
		LOGD("JNI_PCMDataListener->pData == NULL");
		return;
	}

	if(objPCMDataListenerr == NULL) {
		LOGD("JNI_PCMDataListener->objPCMDataListenerr == NULL");
		return;
	}

	JNIEnv* env = NULL;
	jint ret = gJavaVM->AttachCurrentThread(&env, NULL);
	if (ret < 0 || env == NULL) {
		LOGD("JNI_PCMDataListener->g_JavaVM->AttachCurrentThread fail\n");
		return;
	}

	jbyteArray data_array = env->NewByteArray(datalen);
	if (data_array == NULL) {
		LOGD("JNI_PCMDataListener->env->NewByteArray fail");
		gJavaVM->DetachCurrentThread();
		return;
	}

	env->SetByteArrayRegion(data_array, 0, datalen, (const jbyte*)pData);

	jint jdatalen = (jint)datalen;
	jlong jpUser = 0;
	if (NULL != pUser)
	{
		jpUser = reinterpret_cast<jlong>(pUser);
	}

	jclass dataCallback = env->GetObjectClass(objPCMDataListenerr);
	jmethodID dataCallbackMethod = env->GetMethodID(dataCallback, "onTalkPCMDataListener", "([BIJ)V");
	env->CallVoidMethod(objPCMDataListenerr, dataCallbackMethod, data_array, jdatalen, jpUser);

	jbyte* jpointer = env->GetByteArrayElements(data_array,0);
	env->ReleaseByteArrayElements(data_array,jpointer,0);
	env->DeleteLocalRef(data_array);
	data_array = NULL;

	env->DeleteLocalRef(dataCallback);
	dataCallback = NULL;

	gJavaVM->DetachCurrentThread();
}

// 对讲消息回调
void JNI_MessageListener(unsigned short vChannel, char* content, unsigned int contentlen, char* fromUserID, unsigned int userIDLen, void* pUser) {
	LOGD("JNI_MessageListener-> content len:%d", contentlen);
	if(contentlen <= 0 || content == NULL) {
		LOGD("JNI_MessageListener->content == NULL");
		return;
	}

	if(userIDLen <= 0 || fromUserID == NULL) {
		LOGD("JNI_MessageListener->content == NULL");
		return;
	}

	if(objMessageListener == NULL) {
		LOGD("JNI_MessageListener->objMessageListener == NULL");
		return;
	}

	JNIEnv* env = NULL;
	jint ret = gJavaVM->AttachCurrentThread(&env, NULL);
	if (ret < 0 || env == NULL) {
		LOGD("JNI_MessageListener->g_JavaVM->AttachCurrentThread fail\n");
		return;
	}

	jstring jfromUserID = env->NewStringUTF(fromUserID);
	jstring jcontent = env->NewStringUTF(content);
	jint jvchannel = (jint)vChannel;
	jlong jpUser = (jlong)(*((long*)(pUser)));

	jclass jmsgClass = env->GetObjectClass(objMessageListener);
	jmethodID methodID = env->GetMethodID(jmsgClass, "onTalkMsgListener", "(ILjava/lang/String;Ljava/lang/String;J)V");
	env->CallVoidMethod(objMessageListener, methodID, jvchannel, jcontent, jfromUserID, jpUser);

	env-> DeleteLocalRef(jcontent);
	env-> DeleteLocalRef(jfromUserID);
	env->DeleteLocalRef(jmsgClass);
	jmsgClass = NULL;

	gJavaVM->DetachCurrentThread();
	LOGD("JNI_MessageListener success\n");
}

// 错误数据回调
void JNI_ErrorListener(int ErrorCode, char* pDescribe, unsigned int desLen, void* pUser) {
	LOGD("JNI_ErrorListener-> ErrorCode:%d", ErrorCode);
	if(pDescribe == NULL || desLen <= 0 ) {
		LOGD("JNI_ErrorListener->pDescribe == NULL");
		return;
	}

	if(objErrorListener == NULL) {
		LOGD("JNI_ErrorListener->objErrorListener == NULL");
		return;
	}

	JNIEnv* env = NULL;
	jint ret = gJavaVM->AttachCurrentThread(&env, NULL);
	if (ret < 0 || env == NULL) {
		LOGD("JNI_ErrorListener->g_JavaVM->AttachCurrentThread fail\n");
		return;
	}

	jstring jdescribe = env->NewStringUTF(pDescribe);
	jint jErrorCode = (jint)ErrorCode;
	jlong jpUser = (jlong)(*((long*)(pUser)));

	jclass jerrorClass = env->GetObjectClass(objErrorListener);
	jmethodID methodID = env->GetMethodID(jerrorClass, "onTalkErrorListener", "(ILjava/lang/String;J)V");
	env->CallVoidMethod(objErrorListener, methodID, jErrorCode, jdescribe, jpUser);

	env-> DeleteLocalRef(jdescribe);
	env->DeleteLocalRef(jerrorClass);
	jerrorClass = NULL;

	gJavaVM->DetachCurrentThread();
	LOGD("JNI_ErrorListener success\n");
}


/*
 * Class:     com_hik_mcrsdk_talk_TalkClientSDK
 * Method:    initLib
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_com_hik_mcrsdk_talk_TalkClientSDK_initLib
  (JNIEnv *env, jclass jcls) {
	LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_initLib()");
	bool bRet = Init();
	if(!bRet) {
		LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_initLib() Talk Client init lib fail");
		return false;
	}

	LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_initLib() success");
	return true;
}

/*
 * Class:     com_hik_mcrsdk_talk_TalkClientSDK
 * Method:    finiLib
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_com_hik_mcrsdk_talk_TalkClientSDK_finiLib
  (JNIEnv *env, jclass jcls) {

	Fini();

	if(env == NULL) {
		LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_finiLib() env == NULL");
		return;
	}

	if (objPCMDataListenerr != NULL){
		env->DeleteGlobalRef(objPCMDataListenerr);
		objPCMDataListenerr = NULL;
	}

	if (objMessageListener != NULL){
		env->DeleteGlobalRef(objMessageListener);
		objMessageListener = NULL;
	}

	if (objErrorListener != NULL){
		env->DeleteGlobalRef(objErrorListener);
		objErrorListener = NULL;
	}

	LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_finiLib() success");
}

typedef struct _ST_LOGIN_INFO_FIELD
{
	jfieldID jfld_puid_id;
	jfieldID jfld_servIP_id;
	jfieldID jfld_servPort_id;
	jfieldID jfld_userID_id;
	jfieldID jfld_password_id;
	jfieldID jfld_type_id;
	jfieldID jfld_codecType_id;
}ST_LOGIN_INFO_FIELD;

bool GetLoginInfoField(JNIEnv *env, jobject jloginInfo, ST_LOGIN_INFO_FIELD *st_loginInfoField)
{
	if(env == NULL) {
		LOGD("jni GetLoginInfoField() env == NULL");
		return false;
	}

	if(jloginInfo == NULL) {
		LOGD("jni GetLoginInfoField() jcls_loginInfo == NULL");
		return false;
	}

	if(st_loginInfoField == NULL) {
		LOGD("jni GetLoginInfoField() st_loginInfoField == NULL");
		return false;
	}

	jclass jcls_loginInfo = env->GetObjectClass(jloginInfo);
	if(jcls_loginInfo == NULL) {
		LOGD("jni GetLoginInfoField() jcls_loginInfo == NULL");
		return false;
	}

	st_loginInfoField->jfld_puid_id = env->GetFieldID(jcls_loginInfo, "puid", "Ljava/lang/String;");
	if(st_loginInfoField->jfld_puid_id == NULL) {
		LOGD("jni GetLoginInfoField() st_loginInfoField->jfld_puid_id == NULL");
		env->DeleteLocalRef(jcls_loginInfo);
		return false;
	}

	st_loginInfoField->jfld_servIP_id = env->GetFieldID(jcls_loginInfo, "servIP", "Ljava/lang/String;");
	if(st_loginInfoField->jfld_servIP_id == NULL) {
		LOGD("jni GetLoginInfoField() st_loginInfoField->jfld_servIP_id == NULL");
		env->DeleteLocalRef(jcls_loginInfo);
		return false;
	}

	st_loginInfoField->jfld_servPort_id = env->GetFieldID(jcls_loginInfo, "servPort", "I");
	if(st_loginInfoField->jfld_servPort_id == NULL) {
		LOGD("jni GetLoginInfoField() st_loginInfoField->jfld_servPort_id == NULL");
		env->DeleteLocalRef(jcls_loginInfo);
		return false;
	}

	st_loginInfoField->jfld_userID_id = env->GetFieldID(jcls_loginInfo, "userID", "Ljava/lang/String;");
	if(st_loginInfoField->jfld_userID_id == NULL) {
		LOGD("jni GetLoginInfoField() st_loginInfoField->jfld_userID_id == NULL");
		env->DeleteLocalRef(jcls_loginInfo);
		return false;
	}

	st_loginInfoField->jfld_password_id = env->GetFieldID(jcls_loginInfo, "password", "Ljava/lang/String;");
	if(st_loginInfoField->jfld_password_id == NULL) {
		LOGD("jni GetLoginInfoField() st_loginInfoField->jfld_password_id == NULL");
		env->DeleteLocalRef(jcls_loginInfo);
		return false;
	}

	st_loginInfoField->jfld_type_id = env->GetFieldID(jcls_loginInfo, "type", "S");
	if(st_loginInfoField->jfld_type_id == NULL) {
		LOGD("jni GetLoginInfoField() st_loginInfoField->jfld_type_id == NULL");
		env->DeleteLocalRef(jcls_loginInfo);
		return false;
	}

	st_loginInfoField->jfld_codecType_id = env->GetFieldID(jcls_loginInfo, "codecType", "I");
	if(st_loginInfoField->jfld_codecType_id == NULL) {
		LOGD("jni GetLoginInfoField() st_loginInfoField->jfld_codecType_id == NULL");
		env->DeleteLocalRef(jcls_loginInfo);
		return false;
	}

	env->DeleteLocalRef(jcls_loginInfo);
	LOGD("jni GetLoginInfoField() success");
	return true;
}

bool GetLoginInfoValue(JNIEnv *env, jobject jobj_loginInfo, ST_LOGIN_INFO_FIELD *st_loginInfoField, ST_LOGIN_INFO *st_loginInfo)
{
	/**
	 * 1.GetStringRegion和GetStringUTFRegion这两个函数都有一个len的参数，表示Unicode字符的个数，
	 * 但是要注意，这两个函数会在copy完字符串后，还会操作数组的第len+1个元素（GetStringUTFRegion会把[len+1]赋值为0
	 * 但是GetStringRegion很奇怪，并不会把[len+1]赋为0）！因此分配空间时就要分配len+1
	 * 2.Get/SetStringRegion和Get/SetStringUTFRegion这两对函数是最佳选择，因为缓冲区可以被编译器提前分配，而且永远不会产生内存溢出的异常
	 * 3.Get/SetStringRegion和Get/SetStringUTFRegion不需要手动释放内存
	*/

	if(env == NULL) {
		LOGD("jni GetLoginInfoValue() env == NULL");
		return false;
	}

	if(jobj_loginInfo == NULL) {
		LOGD("jni GetLoginInfoValue() jobj_loginInfo == NULL");
		return false;
	}

	if(st_loginInfoField == NULL) {
		LOGD("jni GetLoginInfoValue() st_loginInfoField == NULL");
		return false;
	}

	if(st_loginInfo == NULL) {
		LOGD("jni GetLoginInfoValue() st_loginInfo == NULL");
		return false;
	}

	int len = 0;
	jstring jstr_puid = (jstring)env->GetObjectField(jobj_loginInfo, st_loginInfoField->jfld_puid_id);
	if (jstr_puid == NULL)
	{
		LOGD("jstr_puid is null");
		return false;
	}

	memset(st_loginInfo->puID, 0, sizeof(st_loginInfo->puID));
	len = env->GetStringLength(jstr_puid);
	if ((len+1) > sizeof(st_loginInfo->puID)) {
		LOGD("jni GetLoginInfoValue() java puid len > 128");
		return false;
	}
	env->GetStringUTFRegion(jstr_puid, 0, len, st_loginInfo->puID);

	jstring jstr_servIp = (jstring)env->GetObjectField(jobj_loginInfo, st_loginInfoField->jfld_servIP_id);
	if (jstr_servIp == NULL)
	{
		LOGD("jstr_servIp is null");
		return false;
	}
	memset(st_loginInfo->servIP, 0, sizeof(st_loginInfo->servIP));
	len = env->GetStringLength(jstr_servIp);
	if ((len+1) > sizeof(st_loginInfo->servIP)) {
		LOGD("jni GetLoginInfoValue() java servIP len > 32");
		return false;
	}
	env->GetStringUTFRegion(jstr_servIp, 0, len, st_loginInfo->servIP);

	jstring jstr_userId = (jstring)env->GetObjectField(jobj_loginInfo, st_loginInfoField->jfld_userID_id);
	if (jstr_userId == NULL)
	{
		LOGD("jstr_userId is null");
		return false;
	}
	memset(st_loginInfo->cuUserID, 0, sizeof(st_loginInfo->cuUserID));
	len = env->GetStringLength(jstr_userId);
	if((len+1) > sizeof(st_loginInfo->cuUserID)) {
		LOGD("jni GetLoginInfoValue() java userID len > 128");
		return false;
	}
	env->GetStringUTFRegion(jstr_userId, 0, len, st_loginInfo->cuUserID);

	jstring jstr_psw = (jstring)env->GetObjectField(jobj_loginInfo, st_loginInfoField->jfld_password_id);
	if (jstr_psw == NULL)
	{
		LOGD("jstr_psw is null");
		return false;
	}
	memset(st_loginInfo->password, 0, sizeof(st_loginInfo->password));
	len = env->GetStringLength(jstr_psw);
	if((len+1) > sizeof(st_loginInfo->password)) {
		LOGD("jni GetLoginInfoValue() java password len > 128");
		return false;
	}
	env->GetStringUTFRegion(jstr_psw, 0, len, st_loginInfo->password);

	st_loginInfo->servPort = env->GetIntField(jobj_loginInfo, st_loginInfoField->jfld_servPort_id);
	st_loginInfo->type = env->GetShortField(jobj_loginInfo, st_loginInfoField->jfld_type_id);
	st_loginInfo->codecType = env->GetIntField(jobj_loginInfo, st_loginInfoField->jfld_codecType_id);

	LOGD("jni GetLoginInfoValue() success");
	return true;
}

bool GetLoginInfo(JNIEnv * env, jobject jloginInfo, ST_LOGIN_INFO* loginInfo) {
	if(env == NULL) {
		LOGD("jni getLoginInfo() env == NULL");
		return false;
	}

	if(jloginInfo == NULL) {
		LOGD("jni getLoginInfo() jloginInfo == NULL");
		return false;
	}

	if(loginInfo == NULL) {
		LOGD("jni getLoginInfo() loginInfo == NULL");
		return false;
	}

	ST_LOGIN_INFO_FIELD st_loginInfoField = {0};
	bool bRet = GetLoginInfoField(env, jloginInfo, &st_loginInfoField);
	if(!bRet) {
		LOGD("jni getLoginInfo() GetLoginInfoField fail");
		return false;
	}

	bRet = GetLoginInfoValue(env, jloginInfo, &st_loginInfoField, loginInfo);
	if(!bRet) {
		LOGD("jni getLoginInfo() GetLoginInfoValue fail");
		return false;
	}

	LOGD("jni getLoginInfo() success");
	return true;
}

/*
 * Class:     com_hik_mcrsdk_talk_TalkClientSDK
 * Method:    login
 * Signature: (Lcom/hik/mcrsdk/talk/LoginInfo;J)Z
 */
JNIEXPORT jboolean JNICALL Java_com_hik_mcrsdk_talk_TalkClientSDK_login
  (JNIEnv * env, jobject jobj, jobject jloginInfo, jlong jpUser) {

	if(env == NULL) {
		LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_login() login env == NULL");
		return false;
	}

	if(jloginInfo == NULL) {
		LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_login() login jloginInfo == NULL");
		return false;
	}

	ST_LOGIN_INFO loginInfo = {0};
	bool bRet = GetLoginInfo(env, jloginInfo, &loginInfo);
	if(!bRet) {
		LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_login() login getLoginInfo fail");
		return false;
	}

	LOGD("*********jni->Login() loginInfo*********");
	LOGD(loginInfo.puID);
	LOGD("jni->Login() puID len:%d", strlen(loginInfo.puID));
	LOGD(loginInfo.cuUserID);
	LOGD("jni->Login() UserID len:%d", strlen(loginInfo.cuUserID));
	LOGD(loginInfo.password);
	LOGD("jni->Login() password len:%d", strlen(loginInfo.password));
	LOGD(loginInfo.servIP);
	LOGD("jni->Login() servIP len:%d", strlen(loginInfo.servIP));
	LOGD("jni->Login() servPort:%d", loginInfo.servPort);
	LOGD("jni->Login() type:%d", loginInfo.type);
	LOGD("jni->Login() codecType:%d", loginInfo.codecType);

	bRet = Login(loginInfo, (void*)(&jpUser));
	if(!bRet) {
		LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_login() login fail");
		return false;
	}

	LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_login() success");
	return true;
}

/*
 * Class:     com_hik_mcrsdk_talk_TalkClientSDK
 * Method:    logout
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_com_hik_mcrsdk_talk_TalkClientSDK_logout
  (JNIEnv * env, jobject jobj) {

	Logout();
	LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_logout() success");
}

/*
 * Class:     com_hik_mcrsdk_talk_TalkClientSDK
 * Method:    inputAudioData
 * Signature: ([BI)Z
 */
JNIEXPORT jboolean JNICALL Java_com_hik_mcrsdk_talk_TalkClientSDK_inputAudioData
  (JNIEnv * env, jobject jobj, jbyteArray jbyteData, jint jiLen) {

	if(env == NULL) {
		LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_inputAudioData() env == NULL");
		return false;
	}

	if(jbyteData == NULL || jiLen <= 0) {
		LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_inputAudioData() jbyteData == NULL");
		return false;
	}

	jbyte* pData = env->GetByteArrayElements(jbyteData, NULL);
	if (pData == NULL) {
		LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_inputAudioData() pData == NULL");
		return false;
	}

	InputAudioData((const char*)pData, (unsigned int)jiLen);

	env->ReleaseByteArrayElements(jbyteData, pData, 0);

	//LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_inputAudioData() success");
	return true;
}

typedef struct _ST_TALK_INFO_FIELD
{
	jfieldID jfld_fromUserID_id;
	jfieldID jfld_toUserID_id;
	jfieldID jfld_deviceIndexCode_id;
	jfieldID jfld_deviceType_id;
	jfieldID jfld_channelNum_id;
}ST_TALK_INFO_FIELD;

bool GetTalkInfoField(JNIEnv *env, jobject jtalkInfo, ST_TALK_INFO_FIELD *st_talkInfoField)
{
	if(env == NULL) {
		LOGD("jni GetTalkInfoField() env == NULL");
		return false;
	}

	if(st_talkInfoField == NULL) {
		LOGD("jni GetTalkInfoField() st_talkInfoField == NULL");
		return false;
	}

	jclass jcls_talkInfo = env->GetObjectClass(jtalkInfo);
	if(jcls_talkInfo == NULL) {
		LOGD("jni GetTalkInfoField() jcls_talkInfo == NULL");
		return false;
	}

	st_talkInfoField->jfld_fromUserID_id = env->GetFieldID(jcls_talkInfo, "fromUserID", "Ljava/lang/String;");
	if(st_talkInfoField->jfld_fromUserID_id == NULL) {
		LOGD("jni GetTalkInfoField() st_talkInfoField->jfld_fromUserID_id == NULL");
		env->DeleteLocalRef(jcls_talkInfo);
		return false;
	}

	st_talkInfoField->jfld_toUserID_id = env->GetFieldID(jcls_talkInfo, "toUserID", "Ljava/lang/String;");
	if(st_talkInfoField->jfld_toUserID_id == NULL) {
		LOGD("jni GetTalkInfoField() st_talkInfoField->jfld_toUserID_id == NULL");
		env->DeleteLocalRef(jcls_talkInfo);
		return false;
	}

	st_talkInfoField->jfld_deviceIndexCode_id = env->GetFieldID(jcls_talkInfo, "deviceIndexCode", "Ljava/lang/String;");
	if(st_talkInfoField->jfld_deviceIndexCode_id == NULL) {
		LOGD("jni GetTalkInfoField() st_talkInfoField->jfld_deviceIndexCode_id == NULL");
		env->DeleteLocalRef(jcls_talkInfo);
		return false;
	}

	st_talkInfoField->jfld_deviceType_id = env->GetFieldID(jcls_talkInfo, "deviceType", "I");
	if(st_talkInfoField->jfld_deviceType_id == NULL) {
		LOGD("jni GetTalkInfoField() st_talkInfoField->jfld_deviceType_id == NULL");
		env->DeleteLocalRef(jcls_talkInfo);
		return false;
	}

	st_talkInfoField->jfld_channelNum_id = env->GetFieldID(jcls_talkInfo, "channelNum", "I");
	if(st_talkInfoField->jfld_channelNum_id == NULL) {
		LOGD("jni GetTalkInfoField() st_talkInfoField->jfld_channelNum_id == NULL");
		env->DeleteLocalRef(jcls_talkInfo);
		return false;
	}

	env->DeleteLocalRef(jcls_talkInfo);
	LOGD("jni GetTalkInfoField() success");
	return true;
}

bool GetTalkInfoValue(JNIEnv *env, jobject jobj_talkInfo, const ST_TALK_INFO_FIELD *st_talkInfoField, ST_TALK_INFO *st_talkInfo)
{
	/**
	 * 1.GetStringRegion和GetStringUTFRegion这两个函数都有一个len的参数，表示Unicode字符的个数，
	 * 但是要注意，这两个函数会在copy完字符串后，还会操作数组的第len+1个元素（GetStringUTFRegion会把[len+1]赋值为0
	 * 但是GetStringRegion很奇怪，并不会把[len+1]赋为0）！因此分配空间时就要分配len+1
	 * 2.Get/SetStringRegion和Get/SetStringUTFRegion这两对函数是最佳选择，因为缓冲区可以被编译器提前分配，而且永远不会产生内存溢出的异常
	 * 3.Get/SetStringRegion和Get/SetStringUTFRegion不需要手动释放内存
	*/

	if(env == NULL) {
		LOGD("jni GetTalkInfoValue() env == NULL");
		return false;
	}

	if(jobj_talkInfo == NULL) {
		LOGD("jni GetTalkInfoValue() jobj_talkInfo == NULL");
		return false;
	}

	if(st_talkInfoField == NULL) {
		LOGD("jni GetTalkInfoValue() st_talkInfoField == NULL");
		return false;
	}

	if(st_talkInfo == NULL) {
		LOGD("jni GetTalkInfoValue() st_talkInfo == NULL");
		return false;
	}

	int len = 0;
	jstring jstr_fromUsrId = (jstring)env->GetObjectField(jobj_talkInfo, st_talkInfoField->jfld_fromUserID_id);
	if (jstr_fromUsrId == NULL)
	{
		LOGD("jni GetTalkInfoValue() jstr_fromUsrId == NULL");
		return false;
	}
	memset(st_talkInfo->cuUserID, 0, sizeof(st_talkInfo->cuUserID));
	len = env->GetStringLength(jstr_fromUsrId);
	if ((len+1) > sizeof(st_talkInfo->cuUserID)) {
		LOGD("jni GetTalkInfoValue() java cuUserID len > 128");
		return false;
	}
	env->GetStringUTFRegion(jstr_fromUsrId, 0, len, st_talkInfo->cuUserID);

	jstring jstr_toUsrId = (jstring)env->GetObjectField(jobj_talkInfo, st_talkInfoField->jfld_toUserID_id);
	if (jstr_toUsrId == NULL)
	{
		LOGD("jni GetTalkInfoValue() jstr_toUsrId == NULL");
		return false;
	}
	memset(st_talkInfo->toUserID, 0, sizeof(st_talkInfo->toUserID));
	len = env->GetStringLength(jstr_toUsrId);
	if ((len+1) > sizeof(st_talkInfo->toUserID)) {
		LOGD("jni GetTalkInfoValue() java toUserID len > 128");
		return false;
	}
	env->GetStringUTFRegion(jstr_toUsrId, 0, len, st_talkInfo->toUserID);

	jstring jstr_devIndexCode = (jstring)env->GetObjectField(jobj_talkInfo, st_talkInfoField->jfld_deviceIndexCode_id);
	if (jstr_devIndexCode == NULL)
	{
		LOGD("jni GetTalkInfoValue() jstr_devIndexCode == NULL");
		return false;
	}
	memset(st_talkInfo->deviceIndexCode, 0, sizeof(st_talkInfo->deviceIndexCode));
	len = env->GetStringLength(jstr_devIndexCode);
	if ((len+1) > sizeof(st_talkInfo->deviceIndexCode)) {
		LOGD("jni GetTalkInfoValue() java device Index Code len > 128");
		return false;
	}
	env->GetStringUTFRegion(jstr_devIndexCode, 0, len, st_talkInfo->deviceIndexCode);

	st_talkInfo->deviceType = env->GetIntField(jobj_talkInfo, st_talkInfoField->jfld_deviceType_id);
	st_talkInfo->channelNum = env->GetIntField(jobj_talkInfo, st_talkInfoField->jfld_channelNum_id);

	LOGD("jni GetTalkInfoValue() success");
	return true;
}

bool GetTalkInfo(JNIEnv * env, jobject jtalkInfo, ST_TALK_INFO* talkInfo) {
	if(env == NULL) {
		LOGD("jni GetTalkInfo() env == NULL");
		return false;
	}

	if(jtalkInfo == NULL) {
		LOGD("jni GetTalkInfo() jtalkInfo == NULL");
		return false;
	}

	if(talkInfo == NULL) {
		LOGD("jni GetTalkInfo() talkInfo == NULL");
		return false;
	}

	ST_TALK_INFO_FIELD st_talkInfoField = {0};
	bool bRet = GetTalkInfoField(env, jtalkInfo, &st_talkInfoField);
	if(!bRet) {
		LOGD("jni GetTalkInfo() GetTalkInfoField fail");
		return false;
	}

	bRet = GetTalkInfoValue(env, jtalkInfo, &st_talkInfoField, talkInfo);
	if(!bRet) {
		LOGD("jni GetTalkInfo() GetTalkInfoValue fail");
		return false;
	}

	LOGD("jni GetTalkInfo() success");
	return true;
}

/*
 * Class:     com_hik_mcrsdk_talk_TalkClientSDK
 * Method:    startTalk
 * Signature: (Lcom/hik/mcrsdk/talk/TalkInfo;)Z
 */
JNIEXPORT jboolean JNICALL Java_com_hik_mcrsdk_talk_TalkClientSDK_startTalk
  (JNIEnv * env, jobject jobj, jobject jtalkInfo) {

	if(env == NULL) {
		LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_startTalk() env == NULL");
		return false;
	}

	if(jtalkInfo == NULL) {
		LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_startTalk() jtalkInfo == NULL");
		return false;
	}

	ST_TALK_INFO talkInfo = {0};

	bool bRet = GetTalkInfo(env, jtalkInfo, &talkInfo);
	if(!bRet) {
		LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_startTalk() GetTalkInfo fail");
		return false;
	}

	LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_startTalk() before StartTalk");

	bRet = StartTalk(talkInfo);
	if(!bRet) {
		LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_startTalk() StartTalk");
		return false;
	}

	LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_startTalk() success");
	return true;
}

/*
 * Class:     com_hik_mcrsdk_talk_TalkClientSDK
 * Method:    stopTalk
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_com_hik_mcrsdk_talk_TalkClientSDK_stopTalk
  (JNIEnv * env, jobject jobj) {

	StopTalk();
	LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_stopTalk() success");
}


JNIEXPORT int JNICALL Java_com_hik_mcrsdk_talk_TalkClientSDK_getDeviceEncodeType
(JNIEnv * env, jobject jobj) {
	return GetDeviceEncodeType();
}

typedef struct _ST_GROUP_JOIN_INFO_FIELD
{
	jfieldID jfld_vChannel_id;
	jfieldID jfld_vChannelPsw_id;
}ST_GROUP_JOIN_INFO_FIELD;

bool GetGroupJoinInfoField(JNIEnv *env, jobject jgroupJoinInfo, ST_GROUP_JOIN_INFO_FIELD *st_groupJoinInfoField)
{
	if(env == NULL) {
		LOGD("jni GetGroupJoinInfoField() env == NULL");
		return false;
	}

	if(jgroupJoinInfo == NULL) {
		LOGD("jni GetGroupJoinInfoField() jcls_groupJoinInfo == NULL");
		return false;
	}

	if(st_groupJoinInfoField == NULL) {
		LOGD("jni GetGroupJoinInfoField() st_groupJoinInfoField == NULL");
		return false;
	}

	jclass jcls_groupJoinInfo = env->GetObjectClass(jgroupJoinInfo);
	if(jcls_groupJoinInfo == NULL) {
		LOGD("jni GetGroupJoinInfoField() jcls_groupJoinInfo == NULL");
		return false;
	}

	st_groupJoinInfoField->jfld_vChannelPsw_id = env->GetFieldID(jcls_groupJoinInfo, "vChannelPsw", "Ljava/lang/String;");
	if(st_groupJoinInfoField->jfld_vChannelPsw_id == NULL) {
		LOGD("jni GetGroupJoinInfoField() st_groupJoinInfoField->jfld_vChannelPsw_id == NULL");
		env->DeleteLocalRef(jcls_groupJoinInfo);
		return false;
	}

	st_groupJoinInfoField->jfld_vChannel_id = env->GetFieldID(jcls_groupJoinInfo, "vChannel", "S");
	if(st_groupJoinInfoField->jfld_vChannel_id == NULL) {
		LOGD("jni GetGroupJoinInfoField() st_groupJoinInfoField->jfld_vChannel_id == NULL");
		env->DeleteLocalRef(jcls_groupJoinInfo);
		return false;
	}

	env->DeleteLocalRef(jcls_groupJoinInfo);
	LOGD("jni GetGroupJoinInfoField() success");
	return true;
}

bool GetGroupJoinInfoValue(JNIEnv *env, jobject jobj_groupJoinInfo, ST_GROUP_JOIN_INFO_FIELD *st_groupJoinInfoField, ST_GROUP_JOIN_INFO *st_groupJoinInfo)
{
	/**
	 * 1.GetStringRegion和GetStringUTFRegion这两个函数都有一个len的参数，表示Unicode字符的个数，
	 * 但是要注意，这两个函数会在copy完字符串后，还会操作数组的第len+1个元素（GetStringUTFRegion会把[len+1]赋值为0
	 * 但是GetStringRegion很奇怪，并不会把[len+1]赋为0）！因此分配空间时就要分配len+1
	 * 2.Get/SetStringRegion和Get/SetStringUTFRegion这两对函数是最佳选择，因为缓冲区可以被编译器提前分配，而且永远不会产生内存溢出的异常
	 * 3.Get/SetStringRegion和Get/SetStringUTFRegion不需要手动释放内存
	*/

	if(env == NULL) {
		LOGD("jni GetGroupJoinInfoValue() env == NULL");
		return false;
	}

	if(jobj_groupJoinInfo == NULL) {
		LOGD("jni GetGroupJoinInfoValue() jobj_groupJoinInfo == NULL");
		return false;
	}

	if(st_groupJoinInfoField == NULL) {
		LOGD("jni GetGroupJoinInfoValue() st_groupJoinInfoField == NULL");
		return false;
	}

	if(st_groupJoinInfo == NULL) {
		LOGD("jni GetGroupJoinInfoValue() st_groupJoinInfo == NULL");
		return false;
	}

	int len = 0;
	jstring jstr_vChannelPsw = (jstring)env->GetObjectField(jobj_groupJoinInfo, st_groupJoinInfoField->jfld_vChannelPsw_id);
	memset(st_groupJoinInfo->vChannelPsw, 0, sizeof(st_groupJoinInfo->vChannelPsw));
	len = env->GetStringLength(jstr_vChannelPsw);
	if ((len+1) > sizeof(st_groupJoinInfo->vChannelPsw)) {
		LOGD("jni GetGroupJoinInfoValue() java toUserID len > 128");
		return false;
	}
	env->GetStringUTFRegion(jstr_vChannelPsw, 0, len, st_groupJoinInfo->vChannelPsw);

	st_groupJoinInfo->vChannel = env->GetIntField(jobj_groupJoinInfo, st_groupJoinInfoField->jfld_vChannel_id);

	LOGD("jni GetGroupJoinInfoValue() success");
	return true;
}

bool GetGroupJoinInfo(JNIEnv * env, jobject jgroupJoinInfo, ST_GROUP_JOIN_INFO* groupJoinInfo) {
	if(env == NULL) {
		LOGD("jni GetGroupJoinInfo() env == NULL");
		return false;
	}

	if(jgroupJoinInfo == NULL) {
		LOGD("jni GetGroupJoinInfo() jgroupJoinInfo == NULL");
		return false;
	}

	if(groupJoinInfo == NULL) {
		LOGD("jni GetGroupJoinInfo() groupJoinInfo == NULL");
		return false;
	}

	ST_GROUP_JOIN_INFO_FIELD st_groupJoinInfoField = {0};
	bool bRet = GetGroupJoinInfoField(env, jgroupJoinInfo, &st_groupJoinInfoField);
	if(!bRet) {
		LOGD("jni GetGroupJoinInfo() GetGroupJoinInfoField fail");
		return false;
	}

	bRet = GetGroupJoinInfoValue(env, jgroupJoinInfo, &st_groupJoinInfoField, groupJoinInfo);
	if(!bRet) {
		LOGD("jni GetGroupJoinInfo() GetGroupJoinInfoValue fail");
		return false;
	}

	LOGD("jni GetGroupJoinInfo() success");
	return true;
}

/*
 * Class:     com_hik_mcrsdk_talk_TalkClientSDK
 * Method:    joinGroup
 * Signature: (Lcom/hik/mcrsdk/talk/GroupJoinInfo;)Z
 */
JNIEXPORT jboolean JNICALL Java_com_hik_mcrsdk_talk_TalkClientSDK_joinGroup
  (JNIEnv * env, jobject jobj, jobject jgroupJoinInfo) {

	if(env == NULL) {
		LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_joinGroup() env == NULL");
		return false;
	}

	if(jgroupJoinInfo == NULL) {
		LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_joinGroup() jgroupJoinInfo == NULL");
		return false;
	}

	ST_GROUP_JOIN_INFO groupJoinInfo = {0};
	bool bRet = GetGroupJoinInfo(env, jgroupJoinInfo, &groupJoinInfo);
	if(!bRet) {
		LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_joinGroup() GetGroupJoinInfo fail");
		return false;
	}

	bRet = JoinGroup(groupJoinInfo);
	if(!bRet) {
		LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_joinGroup() JoinGroup");
		return false;
	}

	LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_joinGroup() success");
	return true;
}

/*
 * Class:     com_hik_mcrsdk_talk_TalkClientSDK
 * Method:    quitGroup
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_com_hik_mcrsdk_talk_TalkClientSDK_quitGroup
  (JNIEnv * env, jobject jobj) {

	bool bRet = QuitGroup();
	if(!bRet) {
		LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_quitGroup() QuitGroup fail");
		return false;
	}

	LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_quitGroup() success");
	return true;
}

/*
 * Class:     com_hik_mcrsdk_talk_TalkClientSDK
 * Method:    startGroupTalk
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_com_hik_mcrsdk_talk_TalkClientSDK_startGroupTalk
  (JNIEnv * env, jobject jobj) {

	bool bRet = StartGroupTalk();
	if(!bRet) {
		LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_startGroupTalk() StartGroupTalk fail");
		return false;
	}

	LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_startGroupTalk() success");
	return true;
}

/*
 * Class:     com_hik_mcrsdk_talk_TalkClientSDK
 * Method:    stopGroupTalk
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_com_hik_mcrsdk_talk_TalkClientSDK_stopGroupTalk
  (JNIEnv * env, jobject jobj) {
	StopGroupTalk();
	LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_stopGroupTalk() success");
}

typedef struct _ST_MSG_INFO_FIELD_ {
	jfieldID jfld_toUserID_id;
	jfieldID jfld_msgContent_id;
}ST_MSG_INFO_FIELD;

bool GetMsgInfoField(JNIEnv * env, jobject jmsgInfo, ST_MSG_INFO* msgInfo) {
	return true;
}

bool GetMsgInfoValue(JNIEnv * env, jobject jmsgInfo, ST_MSG_INFO_FIELD* msgInfofield, ST_MSG_INFO* msgInfo) {
	return true;
}

bool GetMsgInfo(JNIEnv * env, jobject jmsgInfo, ST_MSG_INFO* msgInfo) {
	return true;
}

/*
 * Class:     com_hik_mcrsdk_talk_TalkClientSDK
 * Method:    sendMsg
 * Signature: (Lcom/hik/mcrsdk/talk/MsgInfo;)Z
 */
JNIEXPORT jboolean JNICALL Java_com_hik_mcrsdk_talk_TalkClientSDK_sendMsg
  (JNIEnv * env, jobject jobj, jobject jmsgInfo) {
	if(env == NULL) {
		LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_sendMsg env == NULL");
		return false;
	}

	if(jmsgInfo == NULL) {
		LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_sendMsg jmsgInfo == NULL");
		return false;
	}

	ST_MSG_INFO msgInfo = {0};
	bool bRet = GetMsgInfo(env, jmsgInfo, &msgInfo);
	if(!bRet) {
		LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_sendMsg GetMsgInfo fail");
		return false;
	}

	bRet = SendMsg(msgInfo);
	if(!bRet) {
		LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_sendMsg SendMsg fail");
		return false;
	}

	LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_sendMsg() success");
	return true;
}

/*
 * Class:     com_hik_mcrsdk_talk_TalkClientSDK
 * Method:    sendGroupMsg
 * Signature: (Lcom/hik/mcrsdk/talk/MsgGroupInfo;)Z
 */
JNIEXPORT jboolean JNICALL Java_com_hik_mcrsdk_talk_TalkClientSDK_sendGroupMsg
  (JNIEnv * env, jobject jobj, jobject) {

	LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_sendGroupMsg() success");
	return true;
}

/*
 * Class:     com_hik_mcrsdk_talk_TalkClientSDK
 * Method:    addTalkPCMDataLister
 * Signature: (Lcom/hik/mcrsdk/talk/TalkPCMDataLister;)Z
 */
JNIEXPORT jboolean JNICALL Java_com_hik_mcrsdk_talk_TalkClientSDK_addTalkPCMDataLister
  (JNIEnv * env, jobject jobj, jobject talkPCMDataLister) {
	if (talkPCMDataLister == NULL){
		LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_addTalkPCMDataLister talkPCMDataLister == NULL");
		return false;
	}

	bool bRet = SetPCMDataListener(JNI_PCMDataListener);
	if(!bRet) {
		LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_addTalkPCMDataLister() SetPCMDataListener fail");
		return false;
	}

	objPCMDataListenerr = env->NewGlobalRef(talkPCMDataLister);
	LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_addTalkPCMDataLister success");
	return true;
}

/*
 * Class:     com_hik_mcrsdk_talk_TalkClientSDK
 * Method:    addTalkMsgListener
 * Signature: (Lcom/hik/mcrsdk/talk/TalkMsgListener;)Z
 */
JNIEXPORT jboolean JNICALL Java_com_hik_mcrsdk_talk_TalkClientSDK_addTalkMsgListener
  (JNIEnv * env, jobject jobj, jobject talkMsgListener) {
	if (talkMsgListener == NULL){
		LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_addTalkMsgListener talkMsgListener == NULL");
		return false;
	}

	bool bRet = SetMessageListener(JNI_MessageListener);
	if(!bRet) {
		LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_addTalkMsgListener() SetMessageListener fail");
		return false;
	}

	objMessageListener = env->NewGlobalRef(talkMsgListener);
	LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_addTalkMsgListener success");
	return true;
}

/*
 * Class:     com_hik_mcrsdk_talk_TalkClientSDK
 * Method:    addTalkErrorListener
 * Signature: (Lcom/hik/mcrsdk/talk/TalkErrorListener;)Z
 */
JNIEXPORT jboolean JNICALL Java_com_hik_mcrsdk_talk_TalkClientSDK_addTalkErrorListener
  (JNIEnv * env, jobject jobj, jobject talkErrorListener) {
	if (talkErrorListener == NULL){
		LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_addTalkErrorListener talkErrorListener == NULL");
		return false;
	}

	bool bRet = SetErrorListener(JNI_ErrorListener);
	if(!bRet) {
		LOGD(" Java_com_hik_mcrsdk_talk_TalkClientSDK_addTalkErrorListener() SetErrorListener fail");
		return false;
	}

	objErrorListener = env->NewGlobalRef(talkErrorListener);
	LOGD("Java_com_hik_mcrsdk_talk_TalkClientSDK_addTalkErrorListener success");
	return true;
}

/*
 * Class:     com_hik_mcrsdk_talk_TalkClientSDK
 * Method:    logout
 * Signature: ()V
 */
JNIEXPORT jint JNICALL Java_com_hik_mcrsdk_talk_TalkClientSDK_getErrorCode
  (JNIEnv *, jobject) {
	return GetErrorCode();
}

