/*
 * PushDefine.h
 *
 *  Created on: 2014-3-14
 *      Author: weilinfeng
 */

#ifndef PUSHDEFINE_H_
#define PUSHDEFINE_H_


/** @struct REVERSE_NOTIC_REQ_INFO
 *  @brief  反向通知请求结构体。
 *
 */
typedef struct _HEADER_INFO_
{
	int magic;
	short channel;
	short length;
}HEADER_INFO, *PHEADER_INFO;


/** @struct LUCENCY_IN_RSP_INFO
 *  @brief  响应透明通道（进）结构体。
 *
 */
typedef struct LUCENCY_IN_RSP_INFO
{
    char mcuSessionId[128]; // MCU会话ID
    int  seesionIdLen;      // MCU会话ID长度
    int  stateCode;         // 状态码，成功或失败
    char iRet[16];          // 保留
}RLUCENCY_IN_RSPINFO, *PLUCENCY_IN_RSP_INFO;

/** @struct HB_REQ_INFO
 *  @brief  请求透明通道心跳结构体。
 *
 */
typedef struct HB_REQ_INFO
{
    char mcuSessionId[128]; // MCU会话ID
    int  seesionIdLen;      // MCU会话ID长度
    char iRet[16];          // 保留
}RHB_REQ_INFO, *PHB_REQ_INFO;

/** @struct PHB_RSP_INFO
 *  @brief  响应透明通道心跳结构体。
 *
 */
typedef struct HB_RSP_INFO
{
    char mcuSessionId[128]; // MCU会话ID
    int  seesionIdLen;      // MCU会话ID长度
    int  stateCode;         // 状态码，成功或失败
    char iRet[16];          // 保留
}RHB_RSP_INFO, *PHB_RSP_INFO;


/** @struct REVERSE_NOTIC_RSP_INFO
 *  @brief  反向通知响应结构体。
 *
 */
typedef struct REVERSE_NOTIC_RSP_INFO
{
    char mcuSessionId[128]; // MCU会话ID
    int  seesionIdLen;      // MCU会话ID长度
    int  stateCode;         // 状态码，成功或失败
    char iRet[16];          // 保留
}RREVERSE_NOTIC_RSP_INFO, *PREVERSE_NOTIC_RSP_INFO;


#endif /* PUSHDEFINE_H_ */
