/*
 * PushClientSDK.cpp
 *
 *  Created on: 2014-3-17
 *      Author: weilinfeng
 */

#include "PushClientSDK.h"
#include "PushManager.h"
#include "MCRPrint.h"

extern bool gInitLib;

CPushManager * pCPushManager = NULL;

PUSHCLIENTSDKAPI bool PushClientInit()
{
	if(!gInitLib) {
		LOGD("PushClient->PushClientInit() MCRSDK not init\n");
		return false;
	}

	if(pCPushManager == NULL) {
		pCPushManager = new CPushManager();
	}

	return true;
}

PUSHCLIENTSDKAPI void PushClientFini()
{
	if(!gInitLib) {
		LOGD("PushClient->PushClientFini() MCRSDK not init\n");
		return;
	}

	if(pCPushManager != NULL)
	{
		delete pCPushManager;
		pCPushManager = NULL;
	}
}


PUSHCLIENTSDKAPI int PushClientConnect(const char *IP, int port, const char* sessionId, void* pUser)
{
	if(!gInitLib) {
		LOGD("PushClient->PushClientConnect() MCRSDK not init\n");
		return -1;
	}

	if(pCPushManager == NULL) {
		LOGD("PushClient->PushClientConnect() pCPushManager == NULL\n");
		return -1;
	}

	int iRet = pCPushManager->Connect(IP, port, sessionId, pUser);
	if(iRet == -1) {
		LOGD("PushClient->PushClientConnect() Connect fail");
		return -1;
	}

	return iRet;
}

PUSHCLIENTSDKAPI void PushClientDisConnect()
{
	if(!gInitLib) {
		LOGD("PushClient->PushClientDisConnect() MCRSDK not init\n");
		return;
	}

	if(pCPushManager == NULL) {
		LOGD("PushClient->PushClientDisConnect() pCPushManager == NULL\n");
		return;
	}

	pCPushManager->DisConnect();
}

PUSHCLIENTSDKAPI bool PushClientSetPacketLister(pPacketLister packetLister)
{
	LOGD("PushClient->PushClientSetPacketLister()\n");
	if(!gInitLib) {
		LOGD("PushClient->PushClientSetPacketLister() MCRSDK not init\n");
		return false;
	}

	if(pCPushManager == NULL) {
		LOGD("PushClient->PushClientSetPacketLister() pCPushManager == NULL\n");
		return false;
	}

	if(packetLister == NULL) {
		LOGD("PushClient->PushClientSetPacketLister() packetLister == NULL\n");
		return false;
	}

	pCPushManager->SetPacketLister(packetLister);

	LOGD("PushClient->PushClientSetPacketLister() success\n");
	return true;
}

PUSHCLIENTSDKAPI bool PushClientSetConnectionLister(pConnectionLister connectionLister)
{
	LOGD("PushClient->PushClientSetConnectionLister()\n");

	if(!gInitLib) {
		LOGD("PushClient->PushClientSetConnectionLister() MCRSDK not init\n");
		return false;
	}

	if(pCPushManager == NULL) {
		LOGD("PushClient->PushClientSetConnectionLister() pCPushManager == NULL\n");
		return false;
	}

	if(connectionLister == NULL)
	{
		LOGD("PushClient->PushClientSetConnectionLister() connectionLister == NULL\n");
		return false;
	}

	pCPushManager->SetConnectionLister(connectionLister);

	LOGD("PushClient->PushClientSetConnectionLister() success\n");

	return true;
}



