/*
 * RtpUdpTransEngine.h
 *
 *  Created on: 2013-5-10
 *      Author: weilinfeng
 */

#ifndef RTPUDPTRANSENGINE_H_
#define RTPUDPTRANSENGINE_H_

#include "HPR_Addr.h"
#include "HPR_Thread.h"
#include "HPR_Utils.h"
#include "HPR_Select.h"
#include "HPR_Socket.h"
#include "HPR_Types.h"
#include "HPR_Mutex.h"
#include "RtpRtcpDefine.h"
#include "RtpPacket.h"
#include "UdpTcpPortPairs.h"
#include "EventWrapperEx.h"
#include "RtspDefine.h"

class CRtspClientEngine;
class CRtpUdpTransEngine
{
public:
	CRtpUdpTransEngine();
	~CRtpUdpTransEngine();

	HPR_BOOL Init(int iIndex, pRtspDataCallback pDataCallback, unsigned int& iClientSsrc, CUdpTcpPortPairs *portPair, CRtspClientEngine* rtspEngine);					// ��ʼ��
	HPR_BOOL Release();

	HPR_BOOL StartRtpTrans();
	HPR_BOOL StopRtpTrans();

	inline int GetLostPacketNum();
private:
	bool MallocMemory();

	void FreeMemory();

	bool HandleMediaInfo();

    // 连接服务器
    HPR_INT32 ConnectServer();
    //断开服务器
    void DisConnectServer();

	void GenerateRTPPacket();
	HPR_BOOL SendRtpPacket();
	HPR_BOOL RecvRtpPacket();

	void ProcRtpData(char* rtpRecvBuf, int en);

	static HPR_VOIDPTR CALLBACK RtpRecvProc(HPR_VOIDPTR pParam);
	static HPR_VOIDPTR CALLBACK RtpSendProc(HPR_VOIDPTR pParam);

public:
	pRtspDataCallback m_pDataCallback;
	CRtspClientEngine *m_pRtspEngine;

	HPR_BOOL m_bInit;
	HPR_BOOL m_bStartTrans;
	HPR_BOOL m_bQuit;
	HPR_HANDLE m_hSendTHandle;
	HPR_HANDLE m_hRecvTHandle;
	HPR_ULONG m_dwSendThreadID;
	HPR_ULONG m_dwRecvThreadID;

	int m_iIndex;
	HPR_SOCK_T m_iRTPSocket;

	HPR_ADDR_T m_remoteaddr;
	unsigned int m_iServerSsrc;

	char* m_pRTPSendBuf;
	int m_iRTPSendLen;

	char* m_pRTPRecvBuf;
	int m_iRTPRecvLen;

	unsigned short m_iLastPacketSeq;
	unsigned int m_iLastPacketTimeStamp;
	int m_iPalyload[4];
	int m_iCurSeq[4];
	int m_iTotalLostPacketNum;


	CRtpPacket* m_pRtpPacketPool[PACKET_BUFFER_NUM];
	int m_iPacketCount;

	CUdpTcpPortPairs* m_pPortPair;

    //链路重置事件
    CEventWrapperEx m_ReseteEvent;
    //超时次数等待时间
    int m_TimeoutCount;
    //数据流标识
    HPR_BOOL m_bNoData;

	// 海康流头信息
	HIK_MEDIAINFO m_MediaInfo;

	// 国标码流标识
	bool bTrans;
	// rtp拆包标识
	bool bUnpack;
};

inline int CRtpUdpTransEngine::GetLostPacketNum()
{
	return m_iTotalLostPacketNum;
}


#endif /* RTPUDPTRANSENGINE_H_ */
