/*
 * RtspDefine.h
 *
 *  Created on: 2013-4-27
 *      Author: weilinfeng
 *
 *   Modify on:2015-3-23
 *      Author: huyf
 *      Des: 增加VTDU错误堆栈结构体定义
 */

#include "RtspClientSDK.h"

#ifndef RTSPDEFINE_H_
#define RTSPDEFINE_H_

// E-HOME定制
//#define __EHOME_PLATFORM__

extern int g_nRtspClientErrorCode;

#define ENGINE_MAX_NUM                      32 // 最大引擎数
#define MAG_2						"livestream"
#define VTDU_4						"hikvision"

#define VERSION_MAG					2
#define VERSION_VTDU_3				3
#define VERSION_VTDU_4				4
#define VERSION_NEW_MAG				5

#define MEDIA_INFO_MAX_NUM			4

#define	RTP_SEND_INTERVAL			10000
#define	RTCP_SEND_INTERVAL			3000

#define	LOOP_INTERVAL				500

#define RTSP_CONNECT_TIMEOUT		20*000

#define RTSP_RTSPBUF_SIZE			5120

//最大RTSP包长度
#define RTSP_PKT_MAXSIZE			3072
//服务器src的最大长度
#define MAX_SERVERSRC               32
//最大认证信息长度
#define MAX_AUTH_LEN                512
//最大username长度
#define MAX_USERNAME_LEN            33
//最大passwd长度
#define MAX_PASSWD_LEN              33

#define MAX_ACCEPTTYEP_LEN			512
#define MAX_HEAD_LEN				256
#define MAX_SINGLERTSP_RTP_COUNT    4
#define MAX_URL_LEN 				1024
#define MAX_ENCRYPTDES_LEN 			64

#define RTSP_SESSION_SIZE			512
#define RTSP_TRANSPORT_SIZE			512
#define RTSP_SERVERPORT_SIZE		256
#define RTSP_INTERLEAVE_SIZE 		256
#define Sream_Header_LEN			40

#define MAX_SCALE 					3
#define MIN_SCALE 					-3
#define NORMAL_SCALE 				0
#define RATE						2
//下载结束标志
#define HEADER_FLAG    				0x68696b24
#define HEADER_FLAG_EX 				0x01020304

#define STREAMENCODING_3GPP_H264 0x00000001 // 编码类型3gpp 264
#define STREAMENCODING_HIK_HK264 0X00000000 // 编码类型HK 264

// HKMI的头
#define HKMI 0x484B4D49

#define VIDEO_HIK264 0x0001 // 目前标准H.264和海康H.264都用这个定义，强烈建议以后标准H.264改用0x0100以与海康H.264区分
#define VIDEO_MPEG2 0x0002 // 标准MPEG2
#define VIDEO_MPEG4 0x0003 // 标准MPEG4
#define VIDEO_MJPEG 0x0004 // Motion Jpeg
#define VIDEO_AVC264 0x0100 // 标准H.264保留，强烈建议以后标准H.264使用这个定义以与海康H.264区分
#define VIDEO_SVC264 0x0110 // SVC保留
#define VIDEO_WMV9 0x0200 // WMV9
#define VIDEO_VC1 0x0201 // VC1
#define VIDEO_REAL 0x0300 // REAL保留

#define SYSTEM_NULL 0x0000 // 没有系统层，纯音频流或视频流
#define SYSTEM_HIK 0x0001 // 海康文件层
#define SYSTEM_MPEG2_PS 0x0002 // PS封装
#define SYSTEM_MPEG2_TS 0x0003 // TS封装
#define SYSTEM_RTP 0x0004 	// rtp封装

// 海康媒体头
typedef struct _HIK_MEDIAINFO_ // modified by gb 081221
{
	unsigned int media_fourcc; // "HKMI": 0x484B4D49 Hikvision Media Information
	unsigned short media_version; // 版本号：指本信息结构版本号，目前为0x0101,即1.01版本，01：主版本号；01：子版本号。
	unsigned short device_id; // 设备ID，便于跟踪/分析
	unsigned short system_format; // 系统封装层
	unsigned short video_format; // 视频编码类型
	unsigned short audio_format; // 音频编码类型
	unsigned char audio_channels; // 通道数，1：单通道；2：双通道
	unsigned char audio_bits_per_sample; // 样位率
	unsigned int audio_samplesrate; // 采样率
	unsigned int audio_bitrate; // 压缩音频码率,单位：bit
	unsigned int reserved[4]; // 保留
} HIK_MEDIAINFO;


// HVAG的头
#define HVAG 0x47415648

#define HVAG_SYSTEM_NULL 0xC000    // 无帧边界原始封装格式
#define HVAG_SYSTEM_RAW 0xC100    // 有帧边界原始封装格式
#define HVAG_SYSTEM_PS 0xC200    // PS封装格式
#define HVAG_SYSTEM_RTP 0xC300   // RTP封装格式
#define HVAG_SYSTEM_RTP_PS 0xC400   // RTP+PS（国标）封装格式

#define HVAG_PRIVATE_NULL 0xC001    // 增加私有头，无帧边界原始封装格式
#define HVAG_PRIVATE_RAW 0xC101    // 增加私有头，有帧边界原始封装格式
#define HVAG_PRIVATE_PS 0xC201    // 增加私有头，PS封装格式，实际不会使用
#define HVAG_PRIVATE_RTP 0xC301   // 增加私有头，RTP封装格式
#define HVAG_PRIVATE_RTP_PS 0xC401   //增加私有头，RTP+PS（国标）封装格式

#define HVAG_VIDEO_RAW 0xC000    // 原始码流编码
#define HVAG_VIDEO_H264 0xC001    // H264编码
#define HVAG_VIDEO_MPEG4 0xC002    // MPEG4编码
// 国标设备扩展头
struct HVAG_MEDIA_HEAD {
	unsigned char media_magic[4]; // HVAG:，字符数组
	unsigned short media_version; // 头结构版本号，目前为x0101，01：主版本号；01：子版本号
	unsigned short rev1; // 保留字段
	unsigned short system_format; // 系统封装层
	unsigned short video_format; // 视频编码类型
	unsigned char rev2[12]; // 保留字段
	unsigned char decode_id[10]; // 解码插件id
	unsigned char rev3[4]; // 保留字段
	unsigned short stream_head_len; // 辅助码流头
};

// SDP信息
typedef struct _sdp_info_ {
	int headlen;
	char header[MAX_HEAD_LEN];
	char mediaurl[MAX_SINGLERTSP_RTP_COUNT][MAX_URL_LEN];
	int mediacount;

} SDP_INFO, *PSDP_INFO;

typedef struct rtspclient_optionparam {

} RTSPCLIENT_OPTIONPARAM, *PRTSPCLIENT_OPTIONPARAM;

typedef struct rtspclient_describeparam {
	char **acceptpresentation; //可接受的presentation类型的列表
	int presentationcount; //presentation类型的个数
	bool bstandardstream; //表示是否是标准码流
	bool bdevicepushdata; //表示是否由设备主动推送码流
	bool bdownload; //表示是否进行下载
} RTSPCLIENT_DESCRIBEPARAM, *PRTSPCLIENT_DESCRIBEPARAM;

typedef struct rtspclient_setupparam {
	char *url;
	int medieIndex;
#ifdef SUPPORT_DB33
	bool bDB33;
	HPR_UINT16 port;
#endif
} RTSPCLIENT_SETUPPARAM, *PRTSPCLIENT_SETUPPARAM;

typedef struct rtspclient_playparam {
	bool bhasPlayRange; //是否带有Range头部
	int timeType; //时间类型
	char* startTime; //开始时间
	char* endTime; //结束时间
	char *playTime; //开始播放时间
	bool bhasPlayScale; //是否带有Scale头部
	float scale; //播放倍率（84210.50.250.125）
	bool bBackward; //表示倒放
} RTSPCLIENT_PLAYPARAM, *PRTSPCLIENT_PLAYPARAM;

typedef struct rtspclient_pauseparam {
	bool bhasPausePoint; //是否带有暂停点
	float pausePoint; //暂停点
} RTSPCLIENT_PAUSEPARAM, *PRTSPCLIENT_PAUSEPARAM;

typedef struct rtspclient_resumeparam {

} RTSPCLIENT_RESUMEPARAM, *PRTSPCLIENT_RESUMEPARAM;

typedef struct rtspclient_heartbeatparam {

} RTSPCLIENT_HEARTBEATPARAM, *PRTSPCLIENT_HEARTBEATPARAM;

typedef struct rtspclient_teardownparam {

} RTSPCLIENT_TEARDOWNPARAM, *PRTSPCLIENT_TEARDOWNPARAM;

// 回放结束标识
typedef struct _DOWNLOAD_BYE_ {
	int iByte;
	int iByteEx;
} DOWNLOAD_BYE;

// 引擎状态枚举
enum RTSPSESSION_STATE {
	RTSPSTATE_DISCONNECT,
	RTSPSTATE_CONNECT,
	RTSPSTATE_DESCRIBE,
	RTSPSTATE_SETUP,
	RTSPSTATE_PLAY,
	RTSPSTATE_PAUSE,
	RTSPSTATE_TEARDOWN
};

// 引擎类型枚举
enum ENGINE_TYPE {
	REALPLAY, PLAYBACK, DOWNLOAD
};

#define RTSP_DESCRIBE_URLFORMAT		"DESCRIBE %s RTSP/1.0\r\nCSeq: %d\r\nUser-Agent: HIKRTSPClient/1.0\r\nAccept: application/sdp\r\n\r\n"
#define RTSP_UDPSETUP_URLFORMAT		"SETUP %s RTSP/1.0\r\nCSeq: %d\r\nUser-Agent: HIKRTSPClient/1.0\r\nTransport: RTP/AVP/UDP;unicast;client_port=%u-%u\r\n\r\n"
#define RTSP_TCPSETUP_URLFORMAT		"SETUP %s RTSP/1.0\r\nCSeq: %d\r\nUser-Agent: HIKRTSPClient/1.0\r\nTransport: RTP/AVP/TCP;interleaved=%u-%u\r\n\r\n"
#define RTSP_PLAY_URLFORMAT			"PLAY %s RTSP/1.0\r\nCSeq: %d\r\nUser-Agent: HIKRTSPClient/1.0\r\nSession:%s\r\nRange: npt=%u.0-\r\n\r\n"
#define RTSP_RANDOMPLAY_URLFORMAT	"PLAY %s RTSP/1.0\r\nCSeq: %d\r\nSession:%s\r\nRange:npt=%d.000000-\r\n\r\n"
#define RTSP_PAUSE_URLFORMAT		"PAUSE %s RTSP/1.0\r\nCSeq: %d\r\nSession:%s\r\n\r\n"
#define RTSP_RESUME_URLFORMAT		"PLAY %s RTSP/1.0\r\nCSeq: %d\r\nSession:%s\r\n\r\n"
#define RTSP_OPTIONS_URLFORMAT		"OPTIONS %s RTSP/1.0\r\nCSeq: %d\r\nUser-agent: HIKRTSPClient/1.0\r\nSession:%s\r\n\r\n"
#define RTSP_TEARDOWN_URLFORMAT		"TEARDOWN %s RTSP/1.0\r\nCSeq: %d\r\nUser-agent: HIKRTSPClient/1.0\r\nSession:%s\r\nConnection:close\r\n\r\n"

// 错误信息结构体 by hyf 2015/3/23
typedef struct errorInfo1
{
    char moduleID[32];
    char businessID[32];
    HPR_UINT64 timestamp;
    int errorCode;
    char errorMsg[32];
}ERRORINFO1,*PERRORINFO1;

// 错误堆栈信息结构体
typedef struct errorStackInfo1
{
    int* count;              // 当前错误堆栈深度
    PERRORINFO1 perrorInfo;
}ERRORSTACKINFO1,*PERRORSTACKINFO1;

#endif /* RTSPDEFINE_H_ */
