/*******************************************************************************
Copyright 2007-2008 Hikvision Digital Technology Co., Ltd.
FileName:		RtspParser.h
Description:	RTSP信令解析
Author:			weilinfeng
Date:			20013-06-28
Modification History:
*******************************************************************************/

#ifndef __RTSPPARSE_H__
#define __RTSPPARSE_H__

#include "HPR_Addr.h"
#include "HPR_String.h"

#include "RtspCommon.h"
#include "RtspDefine.h"

class CRtspParser
{
public:
	CRtspParser();
	~CRtspParser();
	
public:
	status_code GetStatusCodeIndex(char* srcBuf);
	
	bool GetValueIngoreCase(char* srcBuf, char* strTarget, char* dstBuf, int dstBufLen);

	bool IsEnd(char* srcBuf, int buflen);

	bool GetRedirectUrl(char* srcBuf, char* strRedirectUrl);

	bool GetSdpUrl(char* srcBuf, int buflen, PSDP_INFO sdpinfo, char* urlbuf);

	bool GetSession(char* srcBuf, char* strTarget, char* dstBuf, int dstBufLen);

	bool GetServerPort(char* srcBuf, char* strTarget, char* dstBuf, int dstBufLen, int& iServerport);

	bool GetInterleaved(char* srcBuf, char* strTarget, char* dstBuf, int dstBufLen, int& iInterleaved);

	bool GetServerSsrc(char* srcBuf, char* strTarget, char* dstBuf, int dstBufLen);

	HPR_BOOL GetHeadInfoBySDP(const char* enchead, int srcLen, char* dst, int& dstLen);

	long GetExtErrCode(char* buf);

private:
	CRtspCommon m_oRtspCommon;
};

#endif
