/** @file    SystemTransform.h
  * @note    HANGZHOU Hikvison Software Co.,Ltd.All Right Reserved.
  * @brief   SystemTransform header file
  * 
  *  @version    V2.5.0
  *  @author     heyuanqing
  *  @date       2014/12/05
  *  @note       ϸϢص
  * 
  * @note
  *
  * @warning  Windows 32bit /Linux32 bit version
  */

#ifndef _SYSTEM_TRANSFORM_H_
#define _SYSTEM_TRANSFORM_H_

#ifdef WIN32
    #if defined(_WINDLL)
        #define SYSTRANS_API  __declspec(dllexport) 
    #else 
        #define SYSTRANS_API  __declspec(dllimport) 
    #endif
#else
    #ifndef __stdcall
        #define __stdcall
    #endif

    #ifndef SYSTRANS_API
        #define  SYSTRANS_API
    #endif
#endif

#define SWITCH_BY_FILESIZE      1       //ݲ֧
#define SWITCH_BY_TIME          2

#define SUBNAME_BY_INDEX        1       //ݲ֧
#define SUBNAME_BY_GLOBALTIME   2

/************************************************************************
* ״̬붨
************************************************************************/
#define SYSTRANS_OK             0x00000000
#define SYSTRANS_E_HANDLE       0x80000000  //ת
#define SYSTRANS_E_SUPPORT      0x80000001  //Ͳ֧
#define SYSTRANS_E_RESOURCE     0x80000002  //ԴͷŴ
#define SYSTRANS_E_PARA         0x80000003  //
#define SYSTRANS_E_PRECONDITION 0x80000004  //ǰδ㣬˳
#define SYSTRANS_E_OVERFLOW     0x80000005  //
#define SYSTRANS_E_STOP         0x80000006  //ֹͣ״̬
#define SYSTRANS_E_FILE         0x80000007  //ļ
#define SYSTRANS_E_MAX_HANDLE   0x80000008  //·
#define SYSTRANS_E_OTHER        0x800000ff  //

/************************************************************************
* Ͷ
************************************************************************/
#define TRANS_SYSHEAD               1   //ϵͳͷ
#define TRANS_STREAMDATA            2   //ƵݣƵֿƵݣ
#define TRANS_AUDIOSTREAMDATA       3   //Ƶ
#define TRANS_PRIVTSTREAMDATA       4   //˽
#define TRANS_DECODEPARAM           5   //

/************************************************************************
* ݽṹ
************************************************************************/
/**	@enum	 SYSTEM_TYPE
 *	@brief   װʽ
 *	@note	 
 */
typedef enum SYSTEM_TYPE
{
	TRANS_SYSTEM_NULL       = 0x0,
	TRANS_SYSTEM_HIK        = 0x1,  //ļ㣬ڴʹ洢
	TRANS_SYSTEM_MPEG2_PS   = 0x2,  //PSļ㣬Ҫڴ洢Ҳڴ
	TRANS_SYSTEM_MPEG2_TS   = 0x3,  //TSļ㣬Ҫڴ䣬Ҳڴ洢
	TRANS_SYSTEM_RTP        = 0x4,  //RTPļ㣬ڴ
	TRANS_SYSTEM_MPEG4      = 0x5,  //MPEG4ļ㣬ڴ洢
    TRANS_SYSTEM_AVI        = 0x7,  //AVIļ㣬ڴ洢
    TRANS_SYSTEM_GB_PS      = 0x8,  //PSҪڹ곡
    TRANS_SYSTEM_HLS_TS     = 0x9,  //HLSTSװͨTSװ
	TRANS_SYSTEM_RAW        = 0x10,
}SYSTEM_TYPE;

/**	@enum	  DATA_TYPE   
 *	@brief    
 *	@note	  ͨʹøͣҪƵݷֿҪò
 */
typedef enum DATA_TYPE 
{
    MULTI_DATA,             //
    VIDEO_DATA,             //Ƶ
    AUDIO_DATA,             //Ƶ
    PRIVATE_DATA,           //˽
    VIDEO_PARA,             //Ƶ,HK_VIDEO_PACK_PARA
    AUDIO_PARA,             //Ƶ,HK_AUDIO_PACK_PARA
    PRIVATE_PARA            //˽,HK_PRIVATE_PACK_PARA
}DATA_TYPE;

/** @enum   ST_FRAME_TYPE
 *  @brief  ֡
 *  @note
 */
typedef enum _ST_FRAME_TYPE_
{
    ST_VIDEO_BFRAME = 0,
    ST_VIDEO_PFRAME = 1,
    ST_VIDEO_EFRAME = 2,
    ST_VIDEO_IFRAME = 3,
    ST_AUDIO_FRAME  = 4,
    ST_PRIVA_FRAME  = 5,
}ST_FRAME_TYPE;

/**	@enum	 ST_PROTOCOL_TYPE
 *	@brief   ỰЭ
 *	@note	 
 */
typedef enum _ST_PROTOCOL_TYPE_
{
    ST_PROTOCOL_RTSP        = 1,       //RTSPЭ
    ST_PROTOCOL_HIK         = 2,       //˽Э
    SYSTRANS_PROTOCOL_RTSP  = 1,       //ͬST_PROTOCOL_RTSP,ݶư汾Ķ
    SYSTRANS_PROTOCOL_HIK   = 2,       //ͬST_PROTOCOL_HIK,ݶư汾Ķ
}ST_PROTOCOL_TYPE;

/**	@enum	 ST_SESSION_INFO_TYPE     
 *	@brief   ỰϢ
 *	@note	 
 */
typedef enum _ST_SESSION_INFO_TYPE_
{
    ST_SESSION_INFO_SDP        = 1,    //SDPϢ
    ST_HIK_HEAD                = 2,    //40ֽͷ
    SYSTRANS_SESSION_INFO_SDP  = 1,    //ͬST_SESSION_INFO_SDP,ݶư汾Ķ
    SYSTRANS_HIK_HEAD          = 2,    //ͬST_HIK_HEAD,ݶư汾Ķ
}ST_SESSION_INFO_TYPE;

/**	@enum	 ST_ENCRYPT_TYPE    
 *	@brief   
 *	@note	 
 */
typedef enum _ST_ENCRYPT_TYPE_
{
    ST_ENCRYPT_NONE = 0,       //
    ST_ENCRYPT_AES  = 1        //AES 
}ST_ENCRYPT_TYPE;

/** @enum   ST_MARKBIT
 *  @brief  λ
 *  @note
 */
typedef enum _ST_MARKBIT_TYPE_
{
    ST_UNMARK    = 0,    //ûб
    ST_FRAME_END = 1,    //֡(ĿװΪPSTSRTPʱЧ
    ST_NEW_FILE  = 2,    //ļ(ĿװΪMP4Ч)
}ST_MARKBIT_TYPE;

/**	@struct    SYS_TRANS_PARA 
 *	@brief     תװṹ
 *	@note	   SYSTRANS_Createӿڣֺֻ֧˽Э
 */
typedef struct SYS_TRANS_PARA 
{
	unsigned char*  pSrcInfo;       //豸ýϢͷ
	unsigned int    dwSrcInfoLen;   //ǰ̶Ϊ40
	SYSTEM_TYPE     enTgtType;
	unsigned int    dwTgtPackSize;  //ĿΪRTPPS/TSȷװʽʱ趨ÿСޡĿΪAVI趨֡
} SYS_TRANS_PARA;

/**	@struct    ST_SESSION_PARA 
 *	@brief     תװỰϢ
 *	@note	   SYSTRANS_CreateEx֧RTSPЭSDPϢ
 */
typedef struct _ST_SESSION_PARA_ 
{
    ST_SESSION_INFO_TYPE  nSessionInfoType;   //ỰϢֺ֧ͣýͷSDPϢ
    unsigned int          nSessionInfoLen;    //ỰϢ
    unsigned char*        pSessionInfoData;   //ỰϢ
    SYSTEM_TYPE           eTgtType;           //Ŀװ
    unsigned int          nTgtPackSize;       //ĿΪRTPPS/TSȷװʽʱ趨ÿС
} ST_SESSION_PARA,SYS_TRANS_SESSION_PARA;

/**	@struct    AUTO_SWITCH_PARA 
 *	@brief     Զл
 *	@note	 
 */
typedef struct AUTO_SWITCH_PARA
{
	unsigned int    dwSwitchFlag;       //SWITCH_BY_TIMEͨʱл
	unsigned int    dwSwitchValue;      //ʱԷΪλ
	unsigned int    dwSubNameFlag;      //SUBNAME_BY_GLOBALTIME: ļȫʱ
	char            szMajorName[128];   //szMajorName = c:\test,лļ = c:\test_ʱ.mp4
} AUTO_SWITCH_PARA;

/**	@struct   OUTPUTDATA_INFO   
 *	@brief    ݶ
 *	@note	 
 */
typedef struct OUTPUTDATA_INFO 
{
	unsigned char*  pData;              //صݻ棬ָ첽Ĵ
	unsigned int    dwDataLen;          //صݳ
	unsigned int    dwDataType;         //ͣTRANS_SYSHEAD,TRANS_STREAMDATA
} OUTPUTDATA_INFO;

/** @struct   DETAIL_DATA_INFO
 *  @brief    ϸϢ
 *  @note
 */
typedef struct _DETAIL_DATA_INFO_
{
    unsigned char*  pData;             //صݻ棬ָ첽Ĵ
    unsigned int    nDataLen;          //صݳ
    unsigned short  nDataType;         //ͣ궨
    unsigned short  nFrameType;        //֡ͣö
    unsigned int    nTimeStamp;        //ʱ
    unsigned int    nTimeStampHigh;    //ʱλ,ʱֽڵĸʽ
    unsigned short  nMarkbit;          //(Ŀǰ֧֡½ļֱ,μST_MARKBIT_TYPE
    unsigned short  nVersion;          //ṹ汾
    unsigned int    reserved[26];      //ֶΣչ
}DETAIL_DATA_INFO;

/**	@struct   HK_SYSTEM_TIME  
 *	@brief    ϵͳʱ
 *	@note	 
 */
typedef struct _HK_SYSTEM_TIME_
{
    unsigned int           dwYear;          //
    unsigned int           dwMonth;         //
    unsigned int           dwDay;           //
    unsigned int           dwHour;          //Сʱ
    unsigned int           dwMinute;        //
    unsigned int           dwSecond;        //
    unsigned int           dwMilliSecond;   //
    unsigned int           dwReserved;      //
} HK_SYSTEM_TIME;

/**	@struct   HK_VIDEO_PACK_PARA  
 *	@brief    Ƶ 
 *	@note	 
 */
typedef struct _HK_VIDEO_PACK_PARA_ 
{
    unsigned int   dwFrameNum;             //֡
    unsigned int   dwTimeStamp;            //ʱ
    float          fFrameRate;             //֡
    unsigned int   dwReserved;             //
    HK_SYSTEM_TIME stSysTime;              //ȫʱ    
} HK_VIDEO_PACK_PARA;

/**	@struct    HK_AUDIO_PACK_PARA 
 *	@brief     Ƶ
 *	@note	 
 */
typedef struct _HK_AUDIO_PACK_PARA_ 
{
    unsigned int       dwChannels;         //
    unsigned int	   dwBitsPerSample;    //λ
    unsigned int       dwSampleRate;       //
    unsigned int       dwBitRate;          //
	unsigned int       dwTimeStamp;        //ʱ
	unsigned int       dwReserved[3];      //
} HK_AUDIO_PACK_PARA;

/**	@struct    HK_PRIVATE_PACK_PARA 
 *	@brief     ˽ݴ
 *	@note	 
 */
typedef struct _HK_PRIVATE_PACK_PARA_ 
{
    unsigned int          dwPrivateType;    //˽
    unsigned int          dwDataType;       //
    unsigned int          dwSycVideoFrame;  //ͬƵ֡
    unsigned int          dwReserved;       //
	unsigned int          dwTimeStamp;      //ʱ
    unsigned int          dwReserved1[2];   //
} HK_PRIVATE_PACK_PARA;


#ifdef __cplusplus
	extern "C" {
#endif
/************************************************************************
* SYSTRANS_Create                                                  
* ܣ  ͨԴĿķװװʽת
*   phTrans	        - صľ
*		 pstTransInfo       - תϢָ
* ֵ״̬
************************************************************************/
SYSTRANS_API int __stdcall SYSTRANS_Create(void** phTrans, SYS_TRANS_PARA* pstTransInfo);

/************************************************************************
* SYSTRANS_Start                                                 
* ܣ  ʼװʽת
*   hTrans	            - ת
*        szSrcPath          - Դļ·NULLΪ
*        szTgtPath          - Ŀļ·NULLΪ
* ˵  ԴļΪTS֧ļģʽⲿļģʽ
* ֵ״̬
************************************************************************/
SYSTRANS_API int __stdcall SYSTRANS_Start(void* hTrans, const char* szSrcPath, const char* szTgtPath);

/************************************************************************
* SYSTRANS_AutoSwitch                                                 
* ܣ  ĿΪļʱԶл洢ļ
*   hTrans	        - ת
*		  pstPara       - ԶлļĲṹָ
* ˵  ֧һΣöηز֧
* ֵ״̬ 
************************************************************************/
SYSTRANS_API int __stdcall SYSTRANS_AutoSwitch(void* hTrans, AUTO_SWITCH_PARA* pstPara);

/************************************************************************
* SYSTRANS_ManualSwitch                                                 
* ܣ  ĿΪļʱֶл洢ļ
*   hTrans	        - ת
*		 szTgtPath      - һ洢ļ·
* ֵ״̬ 
************************************************************************/
SYSTRANS_API int __stdcall SYSTRANS_ManualSwitch(void* hTrans, const char* szTgtPath);

/************************************************************************
* SYSTRANS_InputData                                                 
* ܣ  ԴΪģʽ
*   hTrans	- ת
*		  pData		        - Դָ
*		  dwDataLen         - ݴС
*		  enType	        - ͣδʹãͳһMULTI_DATA
* ֵ״̬
************************************************************************/
SYSTRANS_API int __stdcall SYSTRANS_InputData(void* hTrans, DATA_TYPE enType, unsigned char* pData, unsigned int dwDataLen);

/************************************************************************
* SYSTRANS_GetTransPercent                                                 
* ܣ  תļģʽʱתٷֱȣʱֻ֧ԴHIKPSMPEG4
*   hTrans	        - ת
*		 pdwPercent     - תٷֱ
* ֵ״̬
************************************************************************/

SYSTRANS_API int __stdcall SYSTRANS_GetTransPercent(void* hTrans,unsigned int* pdwPercent);

/************************************************************************
* SYSTRANS_RegisterOutputDataCallBack                                                 
* ܣ  ĿΪģʽעתݻص
*   hTrans				    - ת
*		 OutputDataCallBack     - ָ
*		 dwUser				    - û
* ֵ״̬
* ˵  3GPPֻ֧ص
************************************************************************/
SYSTRANS_API int __stdcall SYSTRANS_RegisterOutputDataCallBack(void* hTrans, void (__stdcall * pfnOutputDataCallBack)(OUTPUTDATA_INFO* pDataInfo, void* pUser), void* pUser);


/************************************************************************
* SYSTRANS_RegisterOutputDataCallBackEx                                                 
* ܣ  ĿΪģʽעתݻص
*   hTrans				    - ת
*		 OutputDataCallBack	    - ָ
*		 dwUser				    - û
* ֵ״̬
* ˵  ýӿSYSTRANS_RegisterOutputDataCallBackһ£Ϊ
*           V2.3.0.6֮ǰİ汾˽ӿڣʹSYSTRANS_RegisterOutputDataCallBack
************************************************************************/
SYSTRANS_API int __stdcall SYSTRANS_RegisterOutputDataCallBackEx(void* hTrans, void (__stdcall * OutputDataCallBack)(OUTPUTDATA_INFO* pDataInfo, void* pUser), void* pUser);


/************************************************************************
* SYSTRANS_RegisterDetailDataCallBack
* ܣ  ĿΪģʽעתݻص
*   hTrans             - ת
*        pfDetailCbf        - ָ
*        dwUser             - û
* ֵ״̬
* ˵  ݵϸϢ,֧ĿװΪPS/TS/RTP/MP4
************************************************************************/
SYSTRANS_API int __stdcall SYSTRANS_RegisterDetailDataCallBack(void* hTrans, void (__stdcall * pfDetailCbf)(DETAIL_DATA_INFO* pDataInfo, void* pUser), void* pUser);

/************************************************************************
* SYSTRANS_Stop
* ܣ  ֹͣת
*   hTrans	 - ת
* ֵ״̬
************************************************************************/
SYSTRANS_API int __stdcall SYSTRANS_Stop(void* hTrans);

/************************************************************************
* SYSTRANS_Release                                                 
* ܣ  ͷת
*   hTrans	        - ת
* ֵ״̬
************************************************************************/
SYSTRANS_API int __stdcall SYSTRANS_Release(void* hTrans);

/************************************************************************
* SYSTRANS_CreateEx                                              
* ܣ  SDPϢתװ
*   hTrans             - ת
*   eType              - Э
*   pstInfo            - תװỰ
* ֵ״̬
* ˵  ýӿSYSTRANS_CreateչӶʹSDPϢ֧
************************************************************************/
SYSTRANS_API int __stdcall SYSTRANS_CreateEx(void** phTrans, ST_PROTOCOL_TYPE eType, ST_SESSION_PARA* pstInfo);

/************************************************************************
* SYSTRANS_SetGlobalTime                                              
* ܣ  ȫʱ 
*   hTrans	            - ת
*   pstGlobalTime	    - ȫʱ 
* ֵ״̬
* ˵  Դк˽ӣЯȫʱ䣬ԴȫʱΪ׼ûЧ
************************************************************************/
SYSTRANS_API int __stdcall SYSTRANS_SetGlobalTime(void* hTrans, HK_SYSTEM_TIME* pstGlobalTime);

/************************************************************************
* SYSTRANS_SetEncryptKey                                              
* ܣ  Կ
*   hTrans             - ת
*   eType              - 
*   pKey               - Կ
*   nKeyLen            - ԿȣλΪBit
* ֵ״̬
************************************************************************/
SYSTRANS_API int __stdcall SYSTRANS_SetEncryptKey(void* hTrans, ST_ENCRYPT_TYPE eType, char* pKey,  unsigned int nKeyLen);

/************************************************************************
* SYSTRANS_GetVersion                                                 
* ܣ  ȡ汾
*   
* ֵ汾
************************************************************************/
SYSTRANS_API int __stdcall SYSTRANS_GetVersion();

/************************************************************************
* SYSTRANS_OpenStreamAdvanced                                              
* ܣ  SDPϢתװ,ڼ֮ǰư汾
*   hTrans	      - ת
*   nProtocolType	  - Э
*   pstSessionInfo  - SDPϢ
*   pstTransInfo	  - תϢָ
* ֵ״̬
************************************************************************/
SYSTRANS_API long __stdcall SYSTRANS_OpenStreamAdvanced(void** phTrans, int nProtocolType, SYS_TRANS_SESSION_PARA* pstTransSessionInfo);

#ifdef __cplusplus
	}
#endif

#endif //_SYSTEM_TRANSFORM_H_
