/*
 * EventWrapper.cpp
 *
 *  Created on: 2013-2-5
 *      Author: wlf
 */

#include "EventWrapperEX.h"

CEventWrapperEx::CEventWrapperEx()
: m_iTriggered(0)
{
	HPR_CondCreate(&m_Event);
	HPR_MutexCreate(&m_Mutex);
}

CEventWrapperEx::~CEventWrapperEx()
{
	HPR_CondDestroy(&m_Event);
	HPR_MutexDestroy(&m_Mutex);
}

void CEventWrapperEx::Wait()
{
	HPR_MutexLock(&m_Mutex);
	// 如果无信号则等待，有信号则信号置为0（无信号）
	while(m_iTriggered == 0)
	{
		HPR_CondWait(&m_Event, &m_Mutex);
	}

	//reset the trigger
	m_iTriggered = 0;
	HPR_MutexUnlock(&m_Mutex);
}
void CEventWrapperEx::Signal()
{
	HPR_MutexLock(&m_Mutex);

	m_iTriggered = 1;
	HPR_CondSignal(&m_Event);

	HPR_MutexUnlock(&m_Mutex);
}

int CEventWrapperEx::WaitTimeout(int millSecord)
{
	int iresult = -1;
	HPR_MutexLock(&m_Mutex);

	if (m_iTriggered==0)
	{
		HPR_CondTimedWait(&m_Event, &m_Mutex, millSecord);
	}

	if (m_iTriggered==1)
	{
		//reset the trigger
		iresult = 0;
		m_iTriggered = 0;
	}

	HPR_MutexUnlock(&m_Mutex);
	return iresult;
}
