/*
 * MsgManage.cpp
 *
 *  Created on: 2013-2-2
 *      Author: Admin
 */
#include "MsgManage.h"
#include "HPR_Utils.h"
#include "MCRPrint.h"

CMsgManage::CMsgManage()
{
	HPR_MutexCreate(m_pMutex);
}
CMsgManage::~CMsgManage(void)
{
	HPR_MutexDestroy(m_pMutex);
}

void CMsgManage::InsertMsg(int handle, int opt, void* param1, void* param2, void* pUser)
{
	LOGD("CMsgManage::InsertMsg-> handle:%d, opt:%d!", handle, opt);
	memset(&m_stMsgParam, 0, sizeof(ST_MSGPARAM));
	m_stMsgParam.handle = handle;
	m_stMsgParam.opt = opt;
	m_stMsgParam.param1 = NULL;
	m_stMsgParam.param2 = NULL;
	m_stMsgParam.pUser = pUser;

	HPR_MutexLock(m_pMutex);
	m_Msg_Que.push(m_stMsgParam);
	HPR_MutexUnlock(m_pMutex);
}

bool CMsgManage::Run(pRtspMsgCallback pMsgCallback)
{
	HPR_MutexCreate(m_pMutex);
	m_hMsgHandle = HPR_INVALID_HANDLE;
	m_MsgCallback = pMsgCallback;

	m_bQuit = false;
	m_hMsgHandle = HPR_Thread_Create(HandleMsg, this, 0);
	if (HPR_INVALID_HANDLE == m_hMsgHandle) {
    	LOGD("CMsgManage::Run-> create thread fail!");
		return false;
	}

	return true;
}
void CMsgManage::Stop()
{
	m_bQuit = true;
	if(m_hMsgHandle != HPR_INVALID_HANDLE) {
		m_hMsgHandle = (HPR_HANDLE)HPR_INVALID_THREAD;
	}
}

void* CMsgManage::HandleMsg(void* pParam)
{
	CMsgManage* pinstance = reinterpret_cast<CMsgManage*>(pParam);
	while(!pinstance->m_bQuit)
	{
		HPR_MutexLock(pinstance->m_pMutex);
		if (pinstance->m_Msg_Que.size() > 0)
		{
			QUEUE_ST_MSG_PARAMS::value_type& v = pinstance->m_Msg_Que.front();
			pinstance->m_MsgCallback(v.handle, v.opt, v.param1, v.param2, v.pUser);
			LOGD("CMsgManage::HandleMsg-> handle:%d, opt:%d!", v.handle, v.opt);
			pinstance->m_Msg_Que.pop();
		}
		else
		{
			HPR_Sleep(1000);
			//CRtspClientPrint::Print("CMsgManage::HandleMsg-> no msg!");
		}
		HPR_MutexUnlock(pinstance->m_pMutex);
	}

	return NULL;
}
