/*******************************************************************************
Copyright 2007-2008 Hikvision Digital Technology Co., Ltd.
FileName:		RtspCommon.cpp
Description:	RtspCommon.h ʵļ
Author:			Guo Tianwen
Date:			2009-04-28
Modification History:
<1.0> <2009-04-28> <Guo Tianwen> <ʼ״̬ݽձĻȡ״̬>
*******************************************************************************/

#include "RtspCommon.h"
#include <string.h>

// 캯
CRtspCommon::CRtspCommon()
{
	strcpy(&s_rtsp_method_table[0][0], "SETUP");
	strcpy(&s_rtsp_method_table[1][0], "TEARDOWN");
	strcpy(&s_rtsp_method_table[2][0], "PLAY");
	strcpy(&s_rtsp_method_table[3][0], "PAUSE");
	strcpy(&s_rtsp_method_table[4][0], "RECORD");
	strcpy(&s_rtsp_method_table[5][0], "DESCRIBE");
	strcpy(&s_rtsp_method_table[6][0], "ANNOUNCE");
	strcpy(&s_rtsp_method_table[7][0], "OPTIONS");
	strcpy(&s_rtsp_method_table[8][0], "SET_PARAMETER");
	strcpy(&s_rtsp_method_table[9][0], "GET_PARAMETER");
	strcpy(&s_rtsp_method_table[10][0], "UNKNOWN");

	
	strcpy(&s_rtsp_status_table[0][0], "100");

	strcpy(&s_rtsp_status_table[1][0], "200");
	strcpy(&s_rtsp_status_table[2][0], "201");
	strcpy(&s_rtsp_status_table[3][0], "250");

	strcpy(&s_rtsp_status_table[4][0], "300");
	strcpy(&s_rtsp_status_table[5][0], "301");
	strcpy(&s_rtsp_status_table[6][0], "302");
	strcpy(&s_rtsp_status_table[7][0], "303");
	strcpy(&s_rtsp_status_table[8][0], "304");
	strcpy(&s_rtsp_status_table[9][0], "305");
	
	strcpy(&s_rtsp_status_table[10][0], "400");
	strcpy(&s_rtsp_status_table[11][0], "401");
	strcpy(&s_rtsp_status_table[12][0], "402");
	strcpy(&s_rtsp_status_table[13][0], "403");
	strcpy(&s_rtsp_status_table[14][0], "404");
	strcpy(&s_rtsp_status_table[15][0], "405");
	strcpy(&s_rtsp_status_table[16][0], "406");
	strcpy(&s_rtsp_status_table[17][0], "407");
	strcpy(&s_rtsp_status_table[18][0], "408");
	strcpy(&s_rtsp_status_table[19][0], "409");
	strcpy(&s_rtsp_status_table[20][0], "410");
	strcpy(&s_rtsp_status_table[21][0], "411");
	strcpy(&s_rtsp_status_table[22][0], "412");
	strcpy(&s_rtsp_status_table[23][0], "413");
	strcpy(&s_rtsp_status_table[24][0], "414");
	strcpy(&s_rtsp_status_table[25][0], "415");
	strcpy(&s_rtsp_status_table[26][0], "451");
	strcpy(&s_rtsp_status_table[27][0], "452");
	strcpy(&s_rtsp_status_table[28][0], "453");
	strcpy(&s_rtsp_status_table[29][0], "454");
	strcpy(&s_rtsp_status_table[30][0], "455");
	strcpy(&s_rtsp_status_table[31][0], "456");
	strcpy(&s_rtsp_status_table[32][0], "457");
	strcpy(&s_rtsp_status_table[33][0], "458");
	strcpy(&s_rtsp_status_table[34][0], "459");
	strcpy(&s_rtsp_status_table[35][0], "460");
	strcpy(&s_rtsp_status_table[36][0], "461");
	strcpy(&s_rtsp_status_table[37][0], "462");

	strcpy(&s_rtsp_status_table[38][0], "500");
	strcpy(&s_rtsp_status_table[39][0], "501");
	strcpy(&s_rtsp_status_table[40][0], "502");
	strcpy(&s_rtsp_status_table[41][0], "503");
	strcpy(&s_rtsp_status_table[42][0], "504");
	strcpy(&s_rtsp_status_table[43][0], "505");
	strcpy(&s_rtsp_status_table[44][0], "551");

	strcpy(&s_rtsp_status_table[45][0], "000");
}

// 
CRtspCommon::~CRtspCommon()
{
}

/*******************************************************************************
Function:    	GetRtspMethod()
Description:	ȡRTSPַ
Input:			method	-	RTSP
Output:      	
Return:			ַ
*******************************************************************************/
const char* CRtspCommon::GetRtspMethod(rtsp_method method)
{
	return (&s_rtsp_method_table[method][0]);
}

/*******************************************************************************
Function:    	GetRtspMethod()
Description:	ȡRTSPַ
Input:			method	-	RTSPַ
Output:      	
Return:			
*******************************************************************************/
rtsp_method CRtspCommon::GetRtspMethod(const char* method)
{
	int count = sizeof(s_rtsp_method_table)/sizeof(s_rtsp_method_table[0]);
	for (int i = 0; i < count; i++)
	{
		if (strcmp(method, (&s_rtsp_method_table[i][0])) == 0)
		{
			return (rtsp_method)i;
		}
	}

	return RTSP_UNKNOWN;
}

/*******************************************************************************
Function:    	ConvertRtspStatus2Index()
Description:	RTSP״ַ̬תΪ״̬
Input:			pCode	-	RTSPַ
Output:      	
Return:			״̬
*******************************************************************************/
status_code_index CRtspCommon::ConvertRtspStatus2Index(const char* pCode)
{
	for (int i = 0; i < RTSP_STATUS_NUM; i++)
	{
		if (strcmp(pCode, (&s_rtsp_status_table[i][0])) == 0)
		{
			return (status_code_index)i;
		}
	}
	return RTSP_STATUS_UNK;
}

