/*
 * TalkPacket.h
 *
 *  Created on: 2014-6-7
 *      Author: weilinfeng
 */

#ifndef TALKPACKET_H_
#define TALKPACKET_H_

#include "TalkDefine.h"
#include "TalkClientSDK.h"
#include<string.h>

class CTalkPacket {
public:
	//构造函数
	CTalkPacket();
	// 析构函数
	~CTalkPacket();

	// 生成注册包
	int PackRegister(unsigned int sequence, ST_LOGIN_INFO loginInfo, char* dstBuf, int dstBufLen);
	// 生成注销包
	int PackUnRegister(unsigned int sequence, const char* userId, char* dstBuf, int dstBufLen);
	// 生成单呼包
	int PackIndividualCall(unsigned int sequence, ST_TALK_INFO talkInfo, char* dstBuf, int dstBufLen);
	// 生成退出单呼包
	int PackQuitIndividualCall(unsigned int sequence, const char* userId, unsigned int session, char* dstBuf, int dstBufLen);
	// 生成语音数据包
	int PackAudio(const char* pData, unsigned int nDataSize, const char* fromUserId, const char* toUserId, unsigned int session, char* dstBuf, int dstBufLen);
	// 生成心跳包
	int PackKeepAlive(unsigned int sequence, const char* userId, char* dstBuf, int dstBufLen);

	// 生成获取编码类型的包
	int PackGetEncType(unsigned int sequence, ST_DEV_INFO devInfo, char* dstBuf, int dstBufLen);

	bool UnPackGetEncType(const char* pPacket, unsigned int nPacketLen, int& encType);

	// 解析对讲包头
	bool UnpackTalkHdr(const char* pPacket, hpr2_uint32 nPacketLen, talk_hdr* talkHdr, hpr2_uint16* vchan = 0, hpr2_uint8 *rank = 0);
	// 拆注册回复包
	bool UnPackRegister(const char* pPacket, unsigned int nPacketLen, ST_LOGIN_RES_INFO* loginResInfo);
	// 拆单呼回复包
	bool UnPackIndividualCall(const char* pPacket, unsigned int nPacketLen, ST_TALK_RES_INFO* talkResInfo);
	// 拆语音回复包
	bool UnPackAudio(const char* pPacket, unsigned int nPacketLen, unsigned int* offset);
private:
	int getEncType(const char* encTypes);
};

#endif /* TALKPACKET_H_ */
