/*
 * AECSpeaker.h
 *
 *  Created on: 2016-2-24
 *      Author: chifengliang
 */

#ifndef AECSPEAKER_H_
#define AECSPEAKER_H_
#include "ByteBuffer.h"
#include "HPR_Mutex.h"
#include "HIKAEC_mobile.h"
#include <queue>

#define FRAME_SIZE 1280

typedef struct DataLink
{
public:
	DataLink():data(NULL),pNext(NULL){}
	void* data;
	DataLink* pNext;
}DLink;

class AECSpeaker {
public:
	AECSpeaker();
	virtual ~AECSpeaker();

	/**
	 * int sample_rate[in]:采样率
	 * int bits_per_sample[in]: 采样位数
	 * return bool: true 成功  false 失败
	 */
	bool create(int sample_rate, int bits_per_sample);
	/**
	 * 销毁创建的资源
	 */
	void destroy();
	/**
	 * 放入参照数据
	 * void* data[in] 参照数据
	 * int len[in] 参照数据长度
	 */
	void inputConsultData(void* data, int len);
	/**
	 * 回声抑制处理
	 * void* src[in]: 要处理的数据
	 * void* dst[out]: 处理后的数据
	 * int& dstlen[out]: 处理后数据的长度
	 */
	bool proAEC(void* src, int srclen, void* dst, int& dstlen);
private:
	ByteBuffer byteBuf;
	ByteBuffer consultBuf;
	bool isCreate;
	void* aec_param;
	void *aec_handle;
	HPR_MUTEX_T aecLock;
//	DLink* curDLink;
//	DLink* tailDLink;
	std::queue<void*> dqueue;
};

#endif /* AECSPEAKER_H_ */
