/*
 * Denoise.h
 *
 *  Created on: 2015-11-20
 *      Author: chifengliang
 */

#ifndef DENOISE_H_
#define DENOISE_H_

#include <map>
#include "mem_tab.h"
#include "audio_de_noise.h"
#include "HPR_Hpr.h"
#include "HPR_Utils.h"
#include "Define.h"
#include <jni.h>
#include "HPR_Mutex.h"
#include "ByteBuffer.h"

#define AUDIO_FRAME_SIZE 1280 // 一次性处理数据的长度

class Denoise
{
public:
	Denoise(int rate = 16000);
	virtual ~Denoise();
public:
	/**
	 *  srclen, dstlen byte len
	 *	处理音频数据(啸叫)
	 *	env[in]
	 *	jsrcdata[in] 原始数据
	 *	jsrclen[in] 原始数据长度
	 * */
	jbyteArray proNoise(JNIEnv * env, jbyteArray jsrcdata, jint jsrclen);
private:
	/**
	 * 处理音频数据
	 * src[in] 原始数据
	 * srcLen[in] 原始数据长度
	 * dst[out] 目标数据
	 * dstLen[out] 目标数据长度
	 */
	bool proNoisePri(void* src, int srcLen, void* dst, int& dstLen);
private:
	void* handle;

	DENOISE_PARAM param;
	MEM_TAB       mem_tab[1];
	DENOISE_PROCESS_PARAM proc_param;
	int rate;
	HPR_MUTEX_T noiseLock;
	ByteBuffer byteBuf;
	HPR_INT32 lockRet;
};

#endif /* DENOISE_H_ */
