/*
 * hpr2_byte_order.h
 *
 *  Created on: 2014-6-10
 *      Author: weilinfeng
 */

#ifndef HPR2_BYTE_ORDER_H_
#define HPR2_BYTE_ORDER_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "hpr2_types.h"

#if defined(_WIN32) | defined (_WIN64)
#include <windows.h>
#else
#include <arpa/inet.h>
#endif



// 32位转化,从主机字节序转为网络字节序
void hpr2_htonl_v  (void *data, int pos, int n);
// 32位转化，从网络字节序转为主机字节序
void hpr2_ntohl_v(void *data, int pos, int n);
// 16位转化，从主机字节序转为网络字节序
void hpr2_htons_v  (void *data, int pos, int n);
// 16位转化，从网络字节序转为主机字节序
void hpr2_ntohs_v(void *data, int pos, int n);

// 32位转化,从主机字节序转为网络字节序
hpr2_uint32 hpr2_htonl_c(hpr2_uint32);
// 32位转化，从网络字节序转为主机字节序
hpr2_uint32 hpr2_ntohl_c(hpr2_uint32);
// 16位转化，从主机字节序转为网络字节序
hpr2_uint16 hpr2_htons_c(hpr2_uint16);
// 16位转化，从网络字节序转为主机字节序
hpr2_uint16 hpr2_ntohs_c(hpr2_uint16);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* HPR2_BYTE_ORDER_H_ */
