/*
 * CopyRight:	HangZhou Hikvision System Technology Co., Ltd. All	Right Reserved.
 * FileName:	hpr2_mutex.h
 * Desc:		hpr2 mutex.
 * Author:		zhaoyiji
 * Date:		2012-11-12
 * Contact:		zhaoyiji@hikvision.com.cn
 * History:		Created By Zhaoyiji 2012-11-12 (V0.1)
 * */

#ifndef __HPR2_MUTEX_H__
#define __HPR2_MUTEX_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

//#define HPR2_MUTEX_ERROR (-1)
//#define HPR2_MUTEX_OK    (0)

typedef struct hpr2_mutex_t hpr2_mutex_t;

#define HPR2_MUTEX_ATTR_RECURSIVE	0
#define HPR2_MUTEX_ATTR_FAST			1
#define HPR2_MUTEX_ATTR_ERRORCHECK	2

int hpr2_mutex_create(hpr2_mutex_t** handle, int attr);

int hpr2_mutex_lock(hpr2_mutex_t* handle);

int hpr2_mutex_trylock(hpr2_mutex_t* handle);

int hpr2_mutex_unlock(hpr2_mutex_t* handle);

int hpr2_mutex_destroy(hpr2_mutex_t* handle);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
