/*
 * CopyRight:	HangZhou Hikvision System Technology Co., Ltd. All	Right Reserved.
 * FileName:	hpr2_types.h
 * Desc:		hpr2 types.
 * Author:		zhaoyiji
 * Date:		2012-11-12
 * Contact:		zhaoyiji@hikvision.com.cn
 * History:		Created By Zhaoyiji 2012-11-12 (V0.1)
 * */

#ifndef __HPR2_TYPES_H__
#define __HPR2_TYPES_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define HPR2_OK    (0)
#define HPR2_ERR   (-1)
#define HPR2_TRUE  (1)
#define HPR2_FALSE (0)
#define HPR2_INFINITE (-1)

/************************************************************************/
/** integer */
typedef signed char		hpr2_int8;
typedef unsigned char	hpr2_uint8;
typedef signed short	hpr2_int16;
typedef unsigned short	hpr2_uint16;
typedef signed int		hpr2_int32;
typedef unsigned int	hpr2_uint32;
#if defined(_MSC_VER)
	typedef signed __int64	hpr2_int64;
	typedef unsigned __int64 hpr2_uint64;
#elif defined(__GNUC__) || defined(__SYMBIAN32__)
#if defined(__LP64__)
	typedef signed long hpr2_int64;
	typedef unsigned long hpr2_uint64;
#else
	typedef signed long long hpr2_int64;
	typedef unsigned long long hpr2_uint64;
#endif	//defined(__LP64__)
#endif/** #if defined(_MSC_VER) */
/** end integer */
/************************************************************************/

typedef bool			hpr2_bool;

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif


