/*
 * hpr2_byte_order.cpp
 *
 *  Created on: 2014-6-10
 *      Author: weilinfeng
 */
#include "hpr2_byte_order.h"
#include <arpa/inet.h>

/*******************************************************************************
Function:    	htonl_c()
Description:	32位转化,从主机字节序转为网络字节序
Input:			data		-	需要转换的数据
				pos			-	开始位置
				n			-	转换长度
Output:
Return:			无
*******************************************************************************/
void hpr2_htonl_v(void* data, int pos, int n)
{
	for (int i = pos; i < pos + n; ++i)
	{
		((unsigned int*)data)[i] = htonl(((unsigned int*)data)[i]);
	}
}

/*******************************************************************************
Function:    	ntohl_c()
Description:	32位转化，从网络字节序转为主机字节序
Input:			data		-	需要转换的数据
				pos			-	开始位置
				n			-	转换长度
Output:
Return:			无
*******************************************************************************/
void hpr2_ntohl_v(void* data, int pos, int n)
{
	for (int i = pos; i < pos + n; ++i)
	{
		((unsigned int*)data)[i] = ntohl(((unsigned int*)data)[i]);
	}
}

/*******************************************************************************
Function:    	htons_c()
Description:	16位转化，从主机字节序转为网络字节序
Input:			data		-	需要转换的数据
				pos			-	开始位置
				n			-	转换长度
Output:
Return:			无
*******************************************************************************/
void hpr2_htons_v(void* data, int pos, int n)
{
	for (int i = pos; i < pos + n; ++i)
	{
		((unsigned short*)data)[i] = htons(((unsigned short*)data)[i]);
	}
}

/*******************************************************************************
Function:    	ntohs_c()
Description:	16位转化，从网络字节序转为主机字节序
Input:			data		-	需要转换的数据
				pos			-	开始位置
				n			-	转换长度
Output:
Return:			无
*******************************************************************************/
void hpr2_ntohs_v(void* data, int pos, int n)
{
	for (int i = pos; i < pos + n; ++i)
	{
		((unsigned short*)data)[i] = ntohs(((unsigned short*)data)[i]);
	}
}

// 16位转化，从网络字节序转为主机字节序
hpr2_uint32 hpr2_htonl_c(hpr2_uint32 value)
{
	return ntohl(value);
}

// 16位转化，从网络字节序转为主机字节序
hpr2_uint32 hpr2_ntohl_c(hpr2_uint32 value)
{
	return ntohl(value);
}

hpr2_uint16 hpr2_htons_c(hpr2_uint16 value)
{
	return htons(value);
}

hpr2_uint16 hpr2_ntohs_c(hpr2_uint16 value)
{
	return ntohs(value);
}


