/*
 * RtspClientPrint.cpp
 *
 *  Created on: 2010-9-21
 *      Author: Dengsh
 */

#include "MCRPrint.h"
#include "Define.h"

extern int glogflag;
//extern char* glogpath;

#if defined(__SYMBIAN32__)
#include <flogger.h>
#include <e32cmn.h>
#include <string.h>
#elif defined(ANDROID)
#include <android/log.h>
#elif defined(__APPLE__)
//#include <>
//#import <Foundation/Foundation.h>
#include <stdio.h>
#elif defined(_WIN32_WCE)
#include "stdlib.h" 
#else
#endif

void CMCRPrint::Print(const char* format)
{
	if(format == NULL) {
		return;
	}

	if(glogflag == 1) {
		#if defined(__SYMBIAN32__)
			RFileLogger aLog;

			// connection to the server.
			aLog.Connect();
			aLog.CreateLog(_L("MyLog"), _L("rtspclient_log.txt"), EFileLoggingModeAppend);

			TBuf8<256> aLogText;
			aLogText.Copy((const TUint8 *)format, (strlen(format) > 256 ? 256 : strlen(format)));
			aLog.Write(aLogText);

			// close the log file
			aLog.CloseLog();
		#elif defined(ANDROID)
			//__android_log_print(ANDROID_LOG_INFO, LIB_TAG, format);
		#elif defined(__APPLE__)
			//NSLog(format);
			printf(format, "");
		#else
			printf(format);
		#endif
	}
	else if(glogflag == 2)
	{
		// 写文件
	}
}

void CMCRPrint::Print(const char* format, int para)
{
	if(format == NULL) {
		return;
	}

	if(glogflag == 1) {
		#if defined(__SYMBIAN32__)
			RFileLogger aLog;

			// connection to the server.
			aLog.Connect();
			aLog.CreateLog(_L("MyLog"), _L("rtspclient_log.txt"), EFileLoggingModeAppend);

			TBuf8<256> aLogText;
			aLogText.Copy((const TUint8 *)format, (strlen(format) > 256 ? 256 : strlen(format)));
			aLog.Write(aLogText);

			// close the log file
			aLog.CloseLog();
		#elif defined(ANDROID)
			__android_log_print(ANDROID_LOG_INFO, LIB_TAG, format, para);
		#elif defined(__APPLE__)
			//NSLog(format);
			printf(format, para);
		#else
			printf(format, para);
		#endif
	}
	else if(glogflag == 2)
	{
		// 写文件
	}
}

void CMCRPrint::Print( const char* format, int para1, int para2 )
{
	if(format == NULL) {
		return;
	}

	if(glogflag == 1) {
		#if defined(__SYMBIAN32__)
			RFileLogger aLog;

			// connection to the server.
			aLog.Connect();
			aLog.CreateLog(_L("MyLog"), _L("rtspclient_log.txt"), EFileLoggingModeAppend);

			TBuf8<256> aLogText;
			aLogText.Copy((const TUint8 *)format, (strlen(format) > 256 ? 256 : strlen(format)));
			aLog.Write(aLogText);

			// close the log file
			aLog.CloseLog();
		#elif defined(ANDROID)
			__android_log_print(ANDROID_LOG_INFO, LIB_TAG, format, para1, para2);
		#elif defined(__APPLE__)
			//NSLog(format);
			printf(format, para1, para2);
		#else
			printf(format, para1, para2);
		#endif
	}
}

void CMCRPrint::Print( const char* format, int para1, int para2 , int para3)
{
	if(format == NULL) {
		return;
	}

	if(glogflag == 1) {
		#if defined(__SYMBIAN32__)
			RFileLogger aLog;

			// connection to the server.
			aLog.Connect();
			aLog.CreateLog(_L("MyLog"), _L("rtspclient_log.txt"), EFileLoggingModeAppend);

			TBuf8<256> aLogText;
			aLogText.Copy((const TUint8 *)format, (strlen(format) > 256 ? 256 : strlen(format)));
			aLog.Write(aLogText);

			// close the log file
			aLog.CloseLog();
		#elif defined(ANDROID)
			__android_log_print(ANDROID_LOG_INFO, LIB_TAG, format, para1, para2, para3);
		#elif defined(__APPLE__)
			//NSLog(format);
			printf(format, para1, para2, para3);
		#else
			printf(format, para1, para2);
		#endif
	}
	else if(glogflag == 2)
	{
		// 写文件
	}
}

void CMCRPrint::Print(const char* format, char* para)
{
	if(format == NULL || para == NULL) {
		return;
	}

	if(glogflag == 1) {
		#if defined(__SYMBIAN32__)
			RFileLogger aLog;

			// connection to the server.
			aLog.Connect();
			aLog.CreateLog(_L("MyLog"), _L("rtspclient_log.txt"), EFileLoggingModeAppend);

			TBuf8<256> aLogText;
			aLogText.Copy((const TUint8 *)format, (strlen(format) > 256 ? 256 : strlen(format)));
			aLog.Write(aLogText);

			// close the log file
			aLog.CloseLog();
		#elif defined(ANDROID)
			__android_log_print(ANDROID_LOG_INFO, LIB_TAG, format, para);
		#elif defined(__APPLE__)
			//NSLog(format);
			printf(format, para);
		#else
			printf(format, para);
		#endif
	}
	else if(glogflag == 2)
	{
		// 写文件
	}
}

void CMCRPrint::Print(const char* format, char* para1, int para2)
{
	if(format == NULL || para1 == NULL) {
		return;
	}

	if(glogflag == 1) {
		#if defined(__SYMBIAN32__)
			RFileLogger aLog;

			// connection to the server.
			aLog.Connect();
			aLog.CreateLog(_L("MyLog"), _L("rtspclient_log.txt"), EFileLoggingModeAppend);

			TBuf8<256> aLogText;
			aLogText.Copy((const TUint8 *)format, (strlen(format) > 256 ? 256 : strlen(format)));
			aLog.Write(aLogText);

			// close the log file
			aLog.CloseLog();
		#elif defined(ANDROID)
			__android_log_print(ANDROID_LOG_INFO, LIB_TAG, format, para1, para2);
		#elif defined(__APPLE__)
			//NSLog(format);
			printf(format, para1, para2);
		#else
			printf(format, para1, para2);
		#endif
	}
	else if(glogflag == 2)
	{
		// 写文件
	}
}

void CMCRPrint::Print(const char* format, char* para1, char* para2)
{
	if(format == NULL || para1 == NULL || para2 == NULL) {
		return;
	}

	if(glogflag == 1) {
		#if defined(__SYMBIAN32__)
			RFileLogger aLog;

			// connection to the server.
			aLog.Connect();
			aLog.CreateLog(_L("MyLog"), _L("rtspclient_log.txt"), EFileLoggingModeAppend);

			TBuf8<256> aLogText;
			aLogText.Copy((const TUint8 *)format, (strlen(format) > 256 ? 256 : strlen(format)));
			aLog.Write(aLogText);

			// close the log file
			aLog.CloseLog();
		#elif defined(ANDROID)
			__android_log_print(ANDROID_LOG_INFO, LIB_TAG, format, para1, para2);
		#elif defined(__APPLE__)
			//NSLog(format);
			printf(format, para1, para2);
		#else
			printf(format, para1, para2);
		#endif
	}
	else if(glogflag == 2)
	{
		// 写文件
	}
}

void CMCRPrint::Print(const char* format, int para1, char* para2)
{
	if(format == NULL || para2 == NULL) {
		return;
	}

	if(glogflag == 1) {
		#if defined(__SYMBIAN32__)
			RFileLogger aLog;

			// connection to the server.
			aLog.Connect();
			aLog.CreateLog(_L("MyLog"), _L("rtspclient_log.txt"), EFileLoggingModeAppend);

			TBuf8<256> aLogText;
			aLogText.Copy((const TUint8 *)format, (strlen(format) > 256 ? 256 : strlen(format)));
			aLog.Write(aLogText);

			// close the log file
			aLog.CloseLog();
		#elif defined(ANDROID)
			__android_log_print(ANDROID_LOG_INFO, LIB_TAG, format, para1, para2);
		#elif defined(__APPLE__)
			//NSLog(format);
			printf(format, para1, para2);
		#else
			printf(format, para1, para2);
		#endif
	}
	else if(glogflag == 2)
	{
		// 写文件
	}
}

void CMCRPrint::Print(const char* format, int para1, int para2, char* para3)
{
	if(format == NULL || para3 == NULL) {
		return;
	}

	if(glogflag == 1) {
		#if defined(__SYMBIAN32__)
			RFileLogger aLog;

			// connection to the server.
			aLog.Connect();
			aLog.CreateLog(_L("MyLog"), _L("rtspclient_log.txt"), EFileLoggingModeAppend);

			TBuf8<256> aLogText;
			aLogText.Copy((const TUint8 *)format, (strlen(format) > 256 ? 256 : strlen(format)));
			aLog.Write(aLogText);

			// close the log file
			aLog.CloseLog();
		#elif defined(ANDROID)
			__android_log_print(ANDROID_LOG_INFO, LIB_TAG, format, para1, para2, para3);
		#elif defined(__APPLE__)
			//NSLog(format);
			printf(format, para1, para2, para3);
		#else
			printf(format, para1, para2, para3);
		#endif
	}
	else if(glogflag == 2)
	{
		// 写文件
	}
}

void CMCRPrint::Print(const char* format, char* para1, char* para2, char* para3)
{
	if(format == NULL || para1 == NULL || para2 == NULL) {
		return;
	}

	if(glogflag == 1) {
		#if defined(__SYMBIAN32__)
			RFileLogger aLog;

			// connection to the server.
			aLog.Connect();
			aLog.CreateLog(_L("MyLog"), _L("rtspclient_log.txt"), EFileLoggingModeAppend);

			TBuf8<256> aLogText;
			aLogText.Copy((const TUint8 *)format, (strlen(format) > 256 ? 256 : strlen(format)));
			aLog.Write(aLogText);

			// close the log file
			aLog.CloseLog();
		#elif defined(ANDROID)
			__android_log_print(ANDROID_LOG_INFO, LIB_TAG, format, para1, para2, para3);
		#elif defined(__APPLE__)
			//NSLog(format);
			printf(format, para1, para2, para3);
		#else
			printf(format, para1, para2, para3);
		#endif
	}
	else if(glogflag == 2)
	{
		// 写文件
	}
}

void CMCRPrint::Print(const char* format, int para1, char* para2, char* para3)
{
	if(glogflag == 1 || para2 == NULL || para3 == NULL) {
		#if defined(__SYMBIAN32__)
			RFileLogger aLog;

			// connection to the server.
			aLog.Connect();
			aLog.CreateLog(_L("MyLog"), _L("rtspclient_log.txt"), EFileLoggingModeAppend);

			TBuf8<256> aLogText;
			aLogText.Copy((const TUint8 *)format, (strlen(format) > 256 ? 256 : strlen(format)));
			aLog.Write(aLogText);

			// close the log file
			aLog.CloseLog();
		#elif defined(ANDROID)
			__android_log_print(ANDROID_LOG_INFO, LIB_TAG, format, para1, para2, para3);
		#elif defined(__APPLE__)
			//NSLog(format);
			printf(format, para1, para2, para3);
		#else
			printf(format, para1, para2, para3);
		#endif
	}
	else if(glogflag == 2)
	{
		// 写文件
	}
}

void CMCRPrint::Print(const char* format, int para1, int para2, char* para3, char* para4)
{
	if(glogflag == 1 || para3 == NULL || para4 == NULL) {
		#if defined(__SYMBIAN32__)
			RFileLogger aLog;

			// connection to the server.
			aLog.Connect();
			aLog.CreateLog(_L("MyLog"), _L("rtspclient_log.txt"), EFileLoggingModeAppend);

			TBuf8<256> aLogText;
			aLogText.Copy((const TUint8 *)format, (strlen(format) > 256 ? 256 : strlen(format)));
			aLog.Write(aLogText);

			// close the log file
			aLog.CloseLog();
		#elif defined(ANDROID)
			__android_log_print(ANDROID_LOG_INFO, LIB_TAG, format, para1, para2, para3, para4);
		#elif defined(__APPLE__)
			//NSLog(format);
			printf(format, para1, para2, para3, para4);
		#else
			printf(format, para1, para2, para3, para4);
		#endif
	}
	else if(glogflag == 2)
	{
		// 写文件
	}
}




