
#include "stdio.h"
#include "string.h"
#include "hik_malloc.h"

#if defined (__linux__) || (__APPLE__)
#include <stdlib.h>
#endif

#define IS_2_POW_N(X)   (((X)&(X-1)) == 0)

void *  _aligned_malloc(
    size_t size,
    size_t alignment
    )
{
    size_t ptr, r_ptr;
    size_t *reptr;

    if (!IS_2_POW_N(alignment))
    {
        return NULL;
    }

    alignment = (alignment > sizeof(void *) ? alignment : sizeof(void *));

    if ((ptr = (size_t)malloc(size + alignment + sizeof(void *))) == (size_t)NULL)
        return NULL;

    r_ptr = (ptr + alignment + sizeof(void *)) & ~(alignment -1);
    reptr = (size_t *)(r_ptr - sizeof(void *));
    *reptr = ptr;

    return (void *)r_ptr;
}

void   _aligned_free(void *memblock)
{
    size_t ptr;

    if (memblock == NULL)
        return;

    ptr = (size_t)memblock;

    /* ptr points to the pointer to starting of the memory block */
    ptr = (ptr & ~(sizeof(void *) -1)) - sizeof(void *);

    /* ptr is the pointer to the start of memory block*/
    ptr = *((size_t *)ptr);
    free((void *)ptr);
}
