/*
 * ECSManager.h
 *
 *  Created on: 2015-9-23
 *      Author: chifengliang
 */

#ifndef ECSMANAGER_H_
#define ECSMANAGER_H_
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdarg.h>
#include <string>
#include <pthread.h>

#include "SyncQueue.h"

using namespace std;
typedef struct _log_ms
{
	const char* moudle;// log tag
	char _mtime[24];
	const char* tag; // level tag
	char content[2048];
	const char* file;
	const char* func;
	int32_t line;
}LOGMS;

class ECSManager
{
public:
	ECSManager();
	virtual ~ECSManager();
public:
	char* insert(const char* module, const char* content, const char* tag,
			const char* file, const char* func, int line, va_list ap);
	bool open(char* filePath, long fileSize);
	bool close();
	bool isOpen();
	void setFileMaxNum(int num);
private:
	static void *writeFile(void* param);
	void proWriteFile();
	bool checkFile(int i);
	int32_t kprint(char* buf, const char *fmt, va_list args);
	int32_t kprint(char* buf, int bufLen, const char* fmt, ...);
	int32_t get_wide(const char **s);
	void number_to_string (long num, int32_t base, int32_t flags, int32_t wide, int32_t precision, char **s);
private:
	FILE* fp;
	std::string filePath;
	bool hasOpen;
	SyncQueue<LOGMS*>* logQueue;
	pthread_t tid;
	int file_max_num;
};

#endif /* ECSMANAGER_H_ */
