/**
 **************************************
 * create by chifengliang
 * version 1.0.0
 * data 2015-09-25
 **************************************
 */
#ifndef SYNCQUEUE_H_
#define SYNCQUEUE_H_
#include <errno.h>
#include <time.h>
#include <sys/types.h>
#include <queue>
#include "Synchronized.h"
#include <android/log.h>

using namespace std;

template<class Type>
class SyncQueue : public Synchronized
{
public:
	SyncQueue();
	~SyncQueue();
public:
	void push(Type);
	Type pop();
private:
	queue<Type> *p_Queue;
};

template <class Type>
inline SyncQueue<Type>::SyncQueue()
{
	p_Queue = new queue<Type>();
}

template <class Type>
inline SyncQueue<Type>::~SyncQueue()
{
	delete p_Queue;
	p_Queue = NULL;
}


template <class Type>
inline Type SyncQueue<Type>::pop()
{
	Type type;
	lock();
	while (p_Queue->empty())
	{
//		unlock();
//		return NULL;
		try
		{
			wait();
		}
		catch (exception& ex)
		{
#if defined(ANDROID)
			__android_log_write(ANDROID_LOG_ERROR, "SyncQueue", ex.what());
#endif
			throw;
		}
	}
	type = p_Queue->front();
	p_Queue->pop();
	unlock();
	return type;
}

template <class Type>
inline void SyncQueue<Type>::push(Type type)
{
	lock();
	p_Queue->push(type);
	try
	{
		notify();
	}
	catch(exception& ex)
	{
#if defined(ANDROID)
			__android_log_write(ANDROID_LOG_ERROR, "SyncQueue", ex.what());
#endif
		throw;
	}
	unlock();
}
#endif
