/*
 * Synchronized.h
 *
 *  Created on: 2015-9-24
 *      Author: chifengliang
 */

#ifndef SYNCHRONIZED_H_
#define SYNCHRONIZED_H_
#include <pthread.h>
#include <stdio.h>

class Synchronized
{
public:
	Synchronized();
	virtual ~Synchronized();
public:
	void wait();
	bool wait(unsigned long timeout);
	void notify();
	void notify_all();
	void lock();
	bool trylock();
	void unlock();
private:
#ifdef WIN32
	char numNotifies;
	HANDLE semEvent;
	HANDLE semMutex;
	bool isLocked;
#else
	int cond_time_wait(const timespec*);
	pthread_cond_t cond;
	pthread_mutex_t monitor;
#endif
};

#endif /* SYNCHRONIZED_H_ */
